//*****************************************************************************
//*
//*
//*		GameDalliView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameDalli.h"
#include	"GameDalliDoc.h"
#include	"GameDalliView.h"
#include	"System/ComUtility.h"
#include	<mmsystem.h>
#include	"NewPicDlg.h"
#include	"WinAudio.h"
#include	"MainFrm.h"
#include	<math.h>

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 DC_PEN
#define		 DC_PEN				19
#endif
#ifndef		 DC_BRUSH
#define 	 DC_BRUSH			18
#endif
#ifndef 	 AC_SRC_ALPHA
#define		 AC_SRC_ALPHA       0x01
#endif
#ifndef		 IDC_HAND
#define		 IDC_HAND			MAKEINTRESOURCE(32649)
#endif

#define		 PI					3.1415926535897932384626433832795
#define 	 AUDIO_BUFFER		0x4000
#define 	 IDC_UPDATE			0x39AE
#define 	 MAX_POINTS			8
#define 	 FRAME_SIZE			6
#define 	 TEXT_LINE			42


#if (_WIN32_WINNT < 0x0500)
extern "C"	 WINGDIAPI COLORREF __stdcall SetDCBrushColor(HDC, COLORREF);
extern "C"   WINGDIAPI COLORREF __stdcall SetDCPenColor(HDC, COLORREF);
#endif



IMPLEMENT_DYNCREATE(CGameDalliView, CView)

BEGIN_MESSAGE_MAP(CGameDalliView, CView)
	//{{AFX_MSG_MAP(CGameDalliView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_FILE_SAVE				,OnSave)
	ON_COMMAND(ID_RESET					,OnReset)
	ON_COMMAND(ID_START					,OnStart)
	ON_COMMAND(ID_STOP1					,OnStop1)
	ON_COMMAND(ID_STOP2					,OnStop2)
	ON_COMMAND(ID_STOP1EX				,OnStop1)
	ON_COMMAND(ID_STOP2EX				,OnStop2)
	ON_COMMAND(ID_FILE_NEW				,OnNewPic)
	ON_COMMAND(ID_PICTIME				,OnPicTime)
	ON_COMMAND(ID_PICPATH				,OnPicPath)
	ON_COMMAND(ID_STARADD1				,OnStarAdd1)
	ON_COMMAND(ID_STARADD2				,OnStarAdd2)
	ON_COMMAND(ID_STARSUB1				,OnStarSub1)
	ON_COMMAND(ID_STARSUB2				,OnStarSub2)
	ON_COMMAND(ID_POLYINFO				,OnPolyInfo)
	ON_COMMAND(ID_NEXTGAME				,OnNextGame)
	ON_COMMAND(ID_DRAWDEL				,OnDrawDel)
	ON_COMMAND(ID_DRAWMOVE				,OnDrawMove)
	ON_COMMAND(ID_DRAWEDIT				,OnDrawEdit)
	ON_COMMAND(ID_COLORMODE				,OnColorMode)
	ON_COMMAND(ID_USEIMAGE_A			,OnUseImageA)
	ON_COMMAND(ID_USEIMAGE_B			,OnUseImageB)
	ON_COMMAND(ID_USEIMAGE_C			,OnUseImageC)
	ON_COMMAND(ID_USEIMAGE_D			,OnUseImageD)
	ON_COMMAND(ID_SELCOMPORT			,OnSelComPort)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE	,OnSaveUI)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW	,OnNewPicUI)
	ON_UPDATE_COMMAND_UI(ID_POLYINFO	,OnPolyInfoUI)
	ON_UPDATE_COMMAND_UI(ID_COLORMODE	,OnColorModeUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_A	,OnUseImageAUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_B	,OnUseImageBUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_C	,OnUseImageCUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_D	,OnUseImageDUI)
	ON_UPDATE_COMMAND_UI(ID_DRAWMOVE	,OnDrawMoveUI)
	ON_UPDATE_COMMAND_UI(ID_DRAWEDIT	,OnDrawEditUI)
	ON_UPDATE_COMMAND_UI(ID_DRAWDEL		,OnDrawDelUI)
	ON_UPDATE_COMMAND_UI(ID_STOP1EX		,OnStop1Ex)
	ON_UPDATE_COMMAND_UI(ID_STOP2EX		,OnStop2Ex)
	ON_UPDATE_COMMAND_UI(ID_STOP1 		,OnStop1UI)
	ON_UPDATE_COMMAND_UI(ID_STOP2 		,OnStop2UI)
	ON_UPDATE_COMMAND_UI(ID_START 		,OnStartUI)
	ON_UPDATE_COMMAND_UI(ID_RESET		,OnResetUI)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_DRAWMODE,ID_DRAWMODE+23,OnDrawMode)
END_MESSAGE_MAP()


UINT	CGameDalliView::m_uAudioPos;
DWORD	CGameDalliView::m_uLastCling;
short  *CGameDalliView::m_pCling1;
UINT	CGameDalliView::m_uCling1Len;
HRSRC	CGameDalliView::m_hCling1Src;
HGLOBAL	CGameDalliView::m_hCling1Hg;
short  *CGameDalliView::m_pCling2;
UINT	CGameDalliView::m_uCling2Len;
HRSRC	CGameDalliView::m_hCling2Src;
HGLOBAL	CGameDalliView::m_hCling2Hg;
short  *CGameDalliView::m_pDalli;
UINT	CGameDalliView::m_uDalliLen;
HRSRC	CGameDalliView::m_hDalliSrc;
HGLOBAL	CGameDalliView::m_hDalliHg;
short  *CGameDalliView::m_pTick;
UINT	CGameDalliView::m_uTickLen;
HRSRC	CGameDalliView::m_hTickSrc;
HGLOBAL	CGameDalliView::m_hTickHg;
short  *CGameDalliView::m_aPlay[4];
UINT	CGameDalliView::m_aPlayLen[4];
DWORD	CGameDalliView::m_aHgColors[] =
			{
			BGR(0,0,0),
			BGR(188,188,0),
			BGR(255,0,0),
			};
BYTE	CGameDalliView::m_aFont[] =
			{
			#include "Image/Fonts/Arial24.h"
			};

BYTE	CGameDalliView::m_aFontX[] =
			{
			#include "Image/Fonts/Arial16.h"
			};

BYTE	CGameDalliView::m_aFontS[] =
			{
			#include "Image/Fonts/Arial12.h"
			};

extern "C"	int ComCheckPort(int iHandle);

int 	CGameDalliView::m_iDrawItems;
int 	CGameDalliView::m_iDrawState;
int 	CGameDalliView::m_iDrawMode;
int 	CGameDalliView::m_iDrawUsed;
int 	CGameDalliView::m_iDrawType;
int 	CGameDalliView::m_iDrawPoly;
int 	CGameDalliView::m_iDrawBase;
int 	CGameDalliView::m_iDrawStep;
int 	CGameDalliView::m_iDrawOldX;
int 	CGameDalliView::m_iDrawOldY;
int 	CGameDalliView::m_iDrawPosX;
int 	CGameDalliView::m_iDrawPosY;
int 	CGameDalliView::m_iDrawMul;
int 	CGameDalliView::m_iDrawDiv;
int 	CGameDalliView::m_iDrawAddX;
int 	CGameDalliView::m_iDrawAddY;
int 	CGameDalliView::m_aDrawX   [MAX_POLY*MAX_PT];
int 	CGameDalliView::m_aDrawY   [MAX_POLY*MAX_PT];
BYTE 	CGameDalliView::m_aDrawPoly[MAX_POLY*MAX_PT];
BYTE 	CGameDalliView::m_aDrawStep[MAX_POLY*MAX_PT];
CString	CGameDalliView::m_aPolyName[MAX_POLY];
BYTE	CGameDalliView::m_aPolyId  [MAX_POLY];
int		CGameDalliView::m_aPolySize[MAX_POLY];
int  	CGameDalliView::m_aDrawJump[MAX_POLY];
int 	CGameDalliView::m_aPolygons[MAX_POLY*MAX_PT*2];
int		CGameDalliView::m_iPolyCount;


//*****************************************************************************
//*
//*		CGameDalliView
//*
//*****************************************************************************
//  CGameDalliView Konstruktion/Destruktion
CGameDalliView::CGameDalliView()
{
CRegKeys	sKey;
int			iPos;



	m_bColorMode	= 0;
	m_bChanged		= 0;
	m_iPolyInfo		= 1;
	m_iPolyStep		=-1;
	m_iPolyCount	= 0;
	m_uGameNumber	= 0;
	m_uSwitchTime	= 5000;
	m_iAudioStop	= 0;
	m_iAudioRun		= 0;
	m_bRunning		= 0;
	m_iWndSizeX		= 0;
	m_iWndSizeY		= 0;
	m_iNumberX		= 0;
	m_iNumberY		= 0;
	m_uDeltaTick	= 0;
	m_uStartTick	= 0;
	m_aPicText[0]   = 0;
	m_aPicInfo[0]   = 0;
	m_aPicOut [0]   = 0;
	m_aPoints [0]	= 0;
	m_aPoints [1]	= 0;
	m_aBgNum  [0]	= 0;
	m_aBgNum  [1]	= 0;
	m_aStop   [0]	= 0;
	m_aStop   [1]	= 0;
	m_iStop			= 0;
	m_iDone			= 0;
	m_iPort			= 0;
	m_uLastTick		= 0;
	m_iTextLine		= 1;
	m_iStarSize		= 0;
	m_iZoom			= 0;
	m_iStarX		= 136;
	m_iStarY		= 136;
	m_iStarMax		= MAX_POINTS;
	m_iStarRows		= 1;
	m_iDrawState	= 0;
	m_iDrawDiv		= 1;
	m_iDrawDiv		= 1;
	m_iDrawMul		= 1;
	m_iDrawMul		= 1;
	m_iDrawUsed		= -1;
	m_iDrawBase		= -1;
	m_iDrawType		= 1;

	sKey.Open();
	sKey.Get(m_uSwitchTime,"SwitchTime");
	sKey.Get(m_bColorMode ,"ColorMode" );
	sKey.Get(m_iStarSize  ,"StarSize"  );
	sKey.Get(m_iPolyInfo  ,"PolyInfo"  );
	sKey.Get(m_sPicPath	  ,"PicPath"   );
	sKey.Get((int)m_iPort ,"ComPort"   );

	if(m_uSwitchTime< 2000)m_uSwitchTime=2000;
	if(m_uSwitchTime>10000)m_uSwitchTime=10000;

	memset(m_aStars,0xFF,sizeof(m_aStars));

	for(iPos=0;iPos<MAX_POLY;iPos++)
		{
		m_aPolyId[iPos] = iPos;
		}

}

//*****************************************************************************
//*
//*		CGameDalliView
//*
//*****************************************************************************
CGameDalliView::~CGameDalliView()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Set(m_uSwitchTime,"SwitchTime");
	sKey.Set(m_bColorMode ,"ColorMode" );
	sKey.Set(m_iStarSize  ,"StarSize"  );
	sKey.Set(m_iPolyInfo  ,"PolyInfo"  );
	sKey.Set(m_sPicPath	  ,"PicPath"   );
	sKey.Set(m_iPort	  ,"ComPort"   );

	while(!m_iDone)
		{
		m_iStop = 1;
		Sleep(50);
		}

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CGameDalliView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}


//*****************************************************************************
//*
//*		Draw
//*
//*****************************************************************************
void _cdecl Draw(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(DKGRAY_BRUSH);
	pDc->Rectangle(10,10,20,20);

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CGameDalliView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD		dwThread;
HANDLE		hThread;
CRect		sRect;
LPBYTE		pData;
UINT		uSize;
UINT		uPos;
UINT		uLen;



	if(CView::OnCreate(pCreateStruct)==-1)
		{
		return -1;
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)NULL);

	sRect.SetRectEmpty();
	m_cBitmapWnd.Create(WS_CHILD|WS_VISIBLE,sRect,this);
	m_cBitmapWnd.SetBkColor(RGB(0,0,0));
	m_cBitmapWnd.SetDrawCallback (DrawCallback ,this);
	m_cBitmapWnd.SetMouseCallback(MouseCallback,this);

	m_sStarImg1.InsertBitmap(IDB_STAR1);
	m_sStarImg2.InsertBitmap(IDB_STAR2);
	m_sStarImg3.InsertBitmap(IDB_STAR3);

	SelectStar(m_iStarSize);

	hThread = CreateThread(NULL,0x8000,ComThread,this,0,&dwThread);
	CloseHandle(hThread);

	SetTimer(IDC_UPDATE,93,NULL);



	   m_hCling1Src=FindResourceA(NULL,"CLING1","WAVE");
	if(m_hCling1Src)
		{
		m_hCling1Hg	= LoadResource  (NULL,m_hCling1Src);
		uSize		= SizeofResource(NULL,m_hCling1Src);
		pData		= (LPBYTE)LockResource(m_hCling1Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling1	 = (short*)(pData+uPos);
			m_uCling1Len = uLen/2;
			break;
			}
		}

	   m_hCling2Src=FindResourceA(NULL,"CLING2","WAVE");
	if(m_hCling2Src)
		{
		m_hCling2Hg	= LoadResource  (NULL,m_hCling2Src);
		uSize		= SizeofResource(NULL,m_hCling2Src);
		pData		= (LPBYTE)LockResource(m_hCling2Hg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pCling2	 = (short*)(pData+uPos);
			m_uCling2Len = uLen/2;
			break;
			}
		}

	   m_hDalliSrc=FindResourceA(NULL,"DALLI","WAVE");
	if(m_hDalliSrc)
		{
		m_hDalliHg	= LoadResource  (NULL,m_hDalliSrc);
		uSize		= SizeofResource(NULL,m_hDalliSrc);
		pData		= (LPBYTE)LockResource(m_hDalliHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pDalli	 = (short*)(pData+uPos);
			m_uDalliLen = uLen/2;
			break;
			}

		while(m_uDalliLen>0 && *m_pDalli==0)
			{
			m_uDalliLen--;
			m_pDalli++;
			}
		}

	   m_hTickSrc=FindResourceA(NULL,"TICK","WAVE");
	if(m_hTickSrc)
		{
		m_hTickHg	= LoadResource  (NULL,m_hTickSrc);
		uSize		= SizeofResource(NULL,m_hTickSrc);
		pData		= (LPBYTE)LockResource(m_hTickHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pTick	 = (short*)(pData+uPos);
			m_uTickLen = uLen/2;
			break;
			}
		}

	m_iAudioRun	 = 1;
	AudioOpen(44100,16,1,AUDIO_BUFFER);
	AudioPause(1);
	hThread = CreateThread(NULL,0x8000,AudioThread,this,0,&dwThread);
	SetThreadPriority(hThread,THREAD_PRIORITY_HIGHEST);
	CloseHandle(hThread);


	if(ExistFile(m_sPicPath)<2)
		{
		PostMessage(WM_COMMAND,ID_PICPATH);
		}


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CGameDalliView::OnDestroy()
{

	CheckSave();

	AfxGetMainWnd()->ShowWindow(SW_HIDE);
	m_iAudioRun = 0;

	AudioStop();

	while(!m_iAudioStop)
		{
		Sleep(50);
		}

	AudioClose();


	UnlockResource(m_hCling1Hg );
	DeleteObject  (m_hCling1Src);
	UnlockResource(m_hCling2Hg );
	DeleteObject  (m_hCling2Src);
	UnlockResource(m_hDalliHg  );
	DeleteObject  (m_hDalliSrc );
	UnlockResource(m_hTickHg   );
	DeleteObject  (m_hTickSrc  );

	CView::OnDestroy();

}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  CGameDalliView Zeichnen
void CGameDalliView::OnDraw(CDC *pDC)
{
CGameDalliDoc  *pDoc = GetDocument();


	ASSERT_VALID(pDoc);
}

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
#ifdef		_DEBUG
void CGameDalliView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CGameDalliView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}
#endif

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifdef		_DEBUG
CGameDalliDoc *CGameDalliView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGameDalliDoc)));

return (CGameDalliDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CGameDalliView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
BitmapImage	   *pImage;



	if(iSizeX && iSizeY)
		{
		pImage	=  m_cBitmapWnd.GetImage();
		pImage->Box(0,0,iSizeX,iSizeY,BGR(0,0,0));
		memset(m_aStars,0xFF,sizeof(m_aStars));
		SizeWindow(&m_cBitmapWnd,iSizeX,iSizeY);
		m_iWndSizeX   = iSizeX;
		m_iWndSizeY   = iSizeY;
		m_uHgOk		  = 0xFF;
		m_iPolyNow	  = -2;
		m_iTextLine	  = 1;
		}

	CView::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CGameDalliView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{



}

//*****************************************************************************
//*
//*		SetStartPath
//*
//*****************************************************************************
void CGameDalliView::SetStartPath(LPCTSTR pPath)
{


	m_sPicOrig = m_sPicPath;
	m_sPicPath = pPath;

	DelBackSlash(m_sPicPath);

}



//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameDalliView::StartSound(short *pData,unsigned uLen)
{
UINT	uIdx;



	if(!pData || !uLen || uLen>0x40000000)return;


	for(uIdx=0;uIdx<4;uIdx++)
		{
		if(m_aPlayLen[uIdx])continue;

		m_aPlay   [uIdx] = pData;
		m_aPlayLen[uIdx] = uLen;

		break;
		}


}

//*****************************************************************************
//*
//*		AudioThread
//*
//*****************************************************************************
DWORD WINAPI CGameDalliView::AudioThread(LPVOID pParam)
{
CGameDalliView *pThis=(CGameDalliView*)pParam;
short		   *pWave;
short		   *pData;
unsigned		uIdx;
unsigned		uOff;
unsigned		uLen;
int				iVal;

	m_uAudioPos = 0;

	while(pThis->m_iAudioRun)
		{
		pThis->m_sAudioSem.Lock();

			pData = (short*)AudioWritePtr();
		if(!pData)break;

		if(m_uAudioPos+AUDIO_BUFFER/2<m_uDalliLen)				// Dalli-Klick Melodi
			{
			memcpy(pData,m_pDalli+m_uAudioPos,AUDIO_BUFFER);
			m_uAudioPos += AUDIO_BUFFER/2;
			}
		else{
			uLen = m_uDalliLen-m_uAudioPos;
			memcpy(pData,m_pDalli+m_uAudioPos,uLen*2);
			memcpy(pData+uLen,m_pDalli,AUDIO_BUFFER-uLen*2);
			m_uAudioPos = uLen;
			}

		for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
			{
			pData[uOff] /= 8;
			}

		for(uIdx=0;uIdx<4;uIdx++)
			{
			if(!m_aPlayLen[uIdx])continue;

			uLen  = m_aPlayLen[uIdx];
			pWave = m_aPlay   [uIdx];

			for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
				{
				if(uOff>=uLen)break;

				iVal  = pData[uOff];
				iVal += pWave[uOff];

				if(iVal> 0x7FFF)iVal= 0x7FFF;
				if(iVal<-0x7FFF)iVal=-0x7FFF;

				pData[uOff] = iVal;
				}

			m_aPlayLen[uIdx] -= uOff;
			m_aPlay   [uIdx] += uOff;
			}

		AudioWrite(AUDIO_BUFFER);

		pThis->m_sAudioSem.Unlock();
		}


	pThis->m_iAudioStop = 1;


return 1;
}

//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameDalliView::StartSound(LPCTSTR pSound)
{
DWORD		dwThread;
HANDLE		hThread;


	hThread = CreateThread(NULL,0x8000,WaveThread,(void*)pSound,0,&dwThread);
	CloseHandle(hThread);

}

//*****************************************************************************
//*
//*		WaveThread
//*
//*****************************************************************************
DWORD WINAPI CGameDalliView::WaveThread(LPVOID pParam)
{
LPCTSTR		pName=(LPCTSTR)pParam;
unsigned	uDiff;
unsigned	uTick;


	if(!strncmp(pName,"CLING",5))
		{
		uTick	= GetTickCount();
		uDiff	= uTick-m_uLastCling;
		if(uDiff<280)Sleep(280-uDiff);
		m_uLastCling = GetTickCount();
		}

return PlaySound(pName,AfxGetInstanceHandle(),SND_RESOURCE|SND_ASYNC);
}

//*****************************************************************************
//*
//*		OnPolyInfo
//*
//*****************************************************************************
void CGameDalliView::OnPolyInfo()
{

	m_iPolyInfo = !m_iPolyInfo;

}

//*****************************************************************************
//*
//*		OnPolyInfoUI
//*
//*****************************************************************************
void CGameDalliView::OnPolyInfoUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_iPolyInfo);

}

//*****************************************************************************
//*
//*		OnSaveUI
//*
//*****************************************************************************
void CGameDalliView::OnSaveUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_bChanged);

}

//*****************************************************************************
//*
//*		OnNewPicUI
//*
//*****************************************************************************
void CGameDalliView::OnNewPicUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_iDrawState==1);

}

//*****************************************************************************
//*
//*		OnSave
//*
//*****************************************************************************
void CGameDalliView::OnSave()
{

	CheckSave(0);

}

//*****************************************************************************
//*
//*		OnColorMode
//*
//*****************************************************************************
void CGameDalliView::OnColorMode()
{

	m_bColorMode = !m_bColorMode;

}

//*****************************************************************************
//*
//*		OnColorModeUI
//*
//*****************************************************************************
void CGameDalliView::OnColorModeUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_bColorMode);

}

//*****************************************************************************
//*
//*		OnUseImage?UI
//*
//*****************************************************************************
void CGameDalliView::OnUseImageAUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==2);}
void CGameDalliView::OnUseImageBUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==1);}
void CGameDalliView::OnUseImageCUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==0);}
void CGameDalliView::OnUseImageDUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iStarSize==3);}

//*****************************************************************************
//*
//*		OnDraw????UI
//*
//*****************************************************************************
void CGameDalliView::OnDrawMoveUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iDrawState==1 && m_iDrawType==0);pCmdUI->Enable(m_iDrawState==1);}
void CGameDalliView::OnDrawEditUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iDrawState==1 && m_iDrawType==1);pCmdUI->Enable(m_iDrawState==1);}
void CGameDalliView::OnDrawDelUI (CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iDrawState==1 && m_iDrawType==2);pCmdUI->Enable(m_iDrawState==1);}

//*****************************************************************************
//*
//*		OnDraw????
//*
//*****************************************************************************
void CGameDalliView::OnDrawMove(){m_iDrawType=0;}
void CGameDalliView::OnDrawEdit(){m_iDrawType=1;}
void CGameDalliView::OnDrawDel (){m_iDrawType=2;}

//*****************************************************************************
//*
//*		OnPicPath
//*
//*****************************************************************************
void CGameDalliView::OnPicPath()
{
CPathDlg	sDlg;



	sDlg.SetTitle("Pfad mit Bildern");
	sDlg.SetPath((m_sPicOrig.IsEmpty())? m_sPicPath:m_sPicOrig);

	if(sDlg.DoModal()!=IDOK)return;

	m_sPicOrig.Empty();
	m_sPicPath = sDlg.GetPath();
	DelBackSlash(m_sPicPath);


}

//*****************************************************************************
//*
//*		OnPicTime
//*
//*****************************************************************************
void CGameDalliView::OnPicTime()
{
CValueDlg	sDlg;



	sDlg.SetTitle("Schaltzeit einstellen");
	sDlg.SetTextTitle("Weiterschaltzeit in Millisekunden (2000...10000) :");
	sDlg.SetValue(m_uSwitchTime);

	if(sDlg.DoModal()!=IDOK)return;

	m_uSwitchTime = sDlg.GetValue();

	if(m_uSwitchTime< 2000)m_uSwitchTime=2000;
	if(m_uSwitchTime>10000)m_uSwitchTime=10000;

}

//*****************************************************************************
//*
//*		OnStart/StopUI
//*
//*****************************************************************************
void CGameDalliView::OnStartUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning==0 && m_aBgNum[0]!=2 && m_aBgNum[1]!=2);}
void CGameDalliView::OnResetUI(CCmdUI *pCmdUI){pCmdUI->Enable(m_aStop[1]!=0 || m_aStop[0]!=0 || m_aBgNum[0]==2 || m_aBgNum[1]==2);}
void CGameDalliView::OnStop1UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0);}
void CGameDalliView::OnStop2UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[1]==0);}
void CGameDalliView::OnStop1Ex(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0 && m_aStop[1]==0);}
void CGameDalliView::OnStop2Ex(CCmdUI *pCmdUI){pCmdUI->Enable(m_bRunning!=0 && m_aStop[0]==0 && m_aStop[1]==0);}

//*****************************************************************************
//*
//*		OnSelComPort
//*
//*****************************************************************************
void CGameDalliView::OnSelComPort()
{
char		cText[32];
int			iPort;
CTextDlg	sDlg;


	sprintf(cText,"COM%i",m_iPort+1);

	sDlg.SetText(cText);
	sDlg.SetTitle("COM-Port");
	sDlg.SetTextTitle("Bitte hier das COM-Port angeben :");
	if(sDlg.DoModal()!=IDOK)return;

	sDlg.GetText(cText,sizeof(cText));

	if(memicmp(cText,"COM",3))
		{
		iPort = strtoi(cText);
		}
	else{
		iPort = strtoi(cText+3);
		}

	m_iPort = (iPort<=0)? 0:iPort-1;

}

//*****************************************************************************
//*
//*		OnNextGame
//*
//*****************************************************************************
void CGameDalliView::OnNextGame()
{
int			iNum;
CValueDlg	sDlg;


	sDlg.SetValue(m_uGameNumber+1);
	sDlg.SetTitle("Nchstes Spiel");
	sDlg.SetTextTitle("Bitte hier die Spielnummer eingeben :");
	if(sDlg.DoModal()!=IDOK)return;

	iNum = sDlg.GetValue();

	if(m_iDrawState==0)
		{
		iNum--;
		}

	if(iNum>=0 && iNum<1000 && (iNum^m_uGameNumber))
		{
		CheckSave();
		m_uGameNumber = iNum;
		if(m_iDrawState>0)LoadGame(iNum);
		}

}

//*****************************************************************************
//*
//*		OnReset
//*
//*****************************************************************************
void CGameDalliView::OnReset()
{
	Reset();
}


//*****************************************************************************
//*
//*		OnStart
//*
//*****************************************************************************
void CGameDalliView::OnStart()
{
	Start();
}

//*****************************************************************************
//*
//*		OnStop1
//*
//*****************************************************************************
void CGameDalliView::OnStop1()
{
	Stop(0);
}

//*****************************************************************************
//*
//*		OnStop2
//*
//*****************************************************************************
void CGameDalliView::OnStop2()
{
	Stop(1);
}

//*****************************************************************************
//*
//*		Start
//*
//*****************************************************************************
void CGameDalliView::Start()
{
unsigned	uTurn;


	if(m_bRunning    )return;
	if(m_aBgNum[0]==2)return;
	if(m_aBgNum[1]==2)return;


	for(uTurn=0;;uTurn++)
		{
		if(uTurn>=10)
			{
			strcpy(m_aPicText,"Keine Spiele mehr !");
			strcpy(m_aPicInfo,"Keine Spiele mehr !");
			strcpy(m_aPicOut ,"Keine Spiele mehr !");
			m_iTextLine = 1;
			return;
			}

		CheckSave();
		m_uGameNumber++;
		if(LoadGame(m_uGameNumber))break;
		}

	strlcpy(m_aPicOut,m_aPicText,sizeof(m_aPicOut));
	m_uStartTick = GetTickCount();
	m_iTextLine	 = 1;
	m_bRunning	 = 1;
	m_iPolyNow	 =-2;
	m_iPolyStep	 =-1;

	if(m_uGameNumber>1)
		{
		m_sAudioSem.Lock();
		AudioStop();
		m_uAudioPos = 0;
		AudioOpen(44100,16,1,AUDIO_BUFFER);
		m_sAudioSem.Unlock();
		}

	AudioPause(m_iDrawState);

}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CGameDalliView::Stop(unsigned uPlace)
{

	if(uPlace>=2)return;
	if(m_aStop[uPlace^1])return;

	AudioPause(1);

	m_aStop [uPlace] = 1;
	m_aBgNum[uPlace] = 1;

	if(uPlace)StartSound("CLING2");
	else	  StartSound("CLING1");

}

//*****************************************************************************
//*
//*		Reset
//*
//*****************************************************************************
void CGameDalliView::Reset()
{

	AudioPause(1);

	if(strcmp(m_aPicOut,m_aPicInfo))
		{
		strlcpy(m_aPicOut,m_aPicInfo,sizeof(m_aPicOut));
		m_iTextLine	= 1;
		}

	m_iPolyStep = m_iPolyCount;
	m_bRunning  = 0;
	m_aStop [0] = 0;
	m_aStop [1] = 0;
	m_aBgNum[0] = 0;
	m_aBgNum[1] = 0;
}


//*****************************************************************************
//*
//*		SetZoom
//*
//*****************************************************************************
void CGameDalliView::SetZoom(int iZoom)
{

	m_iZoom = iZoom;

	GetWindowRect(&m_sWndRect);
	m_sWndRect.right--;

}

//*****************************************************************************
//*
//*		OnStarAdd1
//*
//*****************************************************************************
void CGameDalliView::OnStarAdd1()
{
	m_aPoints[0] = (m_aPoints[0]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarAdd2
//*
//*****************************************************************************
void CGameDalliView::OnStarAdd2()
{
	m_aPoints[1] = (m_aPoints[1]+1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub1
//*
//*****************************************************************************
void CGameDalliView::OnStarSub1()
{
	m_aPoints[0] = (m_aPoints[0]+m_iStarMax-1)%m_iStarMax;
}

//*****************************************************************************
//*
//*		OnStarSub2
//*
//*****************************************************************************
void CGameDalliView::OnStarSub2()
{
	m_aPoints[1] = (m_aPoints[1]+m_iStarMax-1)%m_iStarMax;
}


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CGameDalliView::OnTimer(UINT_PTR nIdEvent)
{
static BOOL		bLocked=0;
BitmapImage	   *pImage;
DWORD			uTick;
DWORD			uDiff;
DWORD			uColor;
CPoint			sPoint;
int				aPoly[MAX_PT*2];
int				iSizeX;
int				iSizeY;
int				iHeigh;
int				iPixel;
int				iWidth;
int				iPicX;
int				iPicY;
int				iOffX;
int				iOffY;
int				iAddX;
int				iAddY;
int				iAll;
int				iPos;
int				iRow;
int				iOff;
int				iNum;
int				iCol;
int				iId;


	if(nIdEvent==IDC_UPDATE)
		{
		if(!m_iWndSizeX || !m_iWndSizeY)
			{
			return;
			}

		if(bLocked)return;

		bLocked = TRUE;

		if(m_iZoom==2 && m_iDrawState==0)					// Cursor weg schieben bei Zoom
			{
			GetCursorPos(&sPoint);

			if(m_sWndRect.PtInRect(sPoint))
				{
				SetCursorPos(m_sWndRect.right,m_sWndRect.bottom-1);
				}
			}

		uTick	=  GetTickCount();
		pImage	=  m_cBitmapWnd.GetImage();

		if(!m_aStop[0] && !m_aStop[1] && m_bRunning)
			{
			uDiff = uTick-m_uStartTick;

			if(uDiff>=m_uSwitchTime && !m_iDrawState)		// Ein weites Polygon aufdecken
				{
				if(m_iPolyStep<m_iPolyCount)
					{
					m_iPolyStep++;
					StartSound("TICK");
					}
				else{
					Reset();								// Alles aufgedeckt ohne Buzzer
					m_aBgNum[0] = 2;
					m_aBgNum[1] = 2;
					}

				m_uStartTick += m_uSwitchTime;
				}
	 		}

		iOffX	= 0;
		iOffY	= m_iWndSizeY-m_iStarY;
		iPicX	= m_iStarX/m_iStarRows;
		iPicY	= m_iStarY;

		for(iPos=0;iPos<16*m_iStarRows;iPos++)				// Linke Sterne	zeichnen
			{
			iNum = (m_aPoints[0]<=(UINT)iPos)? 0:1;
			iCol =  m_aBgNum [0];
			iRow =  iPos%m_iStarRows;

			if(iNum!=m_aStars[iPos*2+0] || iCol!=m_aStars[60])
				{
				m_aStars[iPos*2+0] = iNum;

				pImage->Box(iOffX,iOffY,iPicX,iPicY,m_aHgColors[iCol]);

				if(iNum)
					{
					iAddX = (iPicX-m_sStarImg.Width ())/2;
					iAddY = (iPicY-m_sStarImg.Height())/2;
					pImage->PutAlpha(m_sStarImg,iOffX+iAddX,iOffY+iAddY);
					}

				m_cBitmapWnd.InvalidateRect(iOffX,iOffY,iPicX,iPicY);
				}

			if(iRow+1>=m_iStarRows)
				{
				iOffY -= iPicY;
				iOffX -= iPicX*(m_iStarRows-1); 
				}
			else{
				iOffX += iPicX;
				}
			}


		iOffX	= m_iWndSizeX-m_iStarX;
		iOffY	= m_iWndSizeY-m_iStarY;
		iPicX	= m_iStarX/m_iStarRows;
		iPicY	= m_iStarY;

		for(iPos=0;iPos<16*m_iStarRows;iPos++)				// Rechte Sterne zeichnen
			{
			iNum = (m_aPoints[1]<=(UINT)iPos)? 0:1;
			iCol =  m_aBgNum [1];
			iRow =  iPos%m_iStarRows;

			if(iNum!=m_aStars[iPos*2+1] || iCol!=m_aStars[61])
				{
				m_aStars[iPos*2+1] = iNum;

				pImage->Box(iOffX,iOffY,iPicX,iPicY,m_aHgColors[iCol]);

				if(iNum)
					{
					iAddX = (iPicX-m_sStarImg.Width ())/2;
					iAddY = (iPicY-m_sStarImg.Height())/2;
					pImage->PutAlpha(m_sStarImg,iOffX+iAddX,iOffY+iAddY);
					}

				m_cBitmapWnd.InvalidateRect(iOffX,iOffY,iPicX,iPicY);
				}

			if(iRow+1>=m_iStarRows)
				{
				iOffY -= iPicY;
				iOffX -= iPicX*(m_iStarRows-1); 
				}
			else{
				iOffX += iPicX;
				}
			}

		if(m_uHgOk!=0)										// Rahmen zeichnen
			{
			m_uHgOk = 0;

			pImage->Box(m_iStarX+0,0,1,m_iWndSizeY,BGR(222,222,222));
			pImage->Box(m_iStarX+1,0,1,m_iWndSizeY,BGR(188,188,188));
			pImage->Box(m_iStarX+2,0,2,m_iWndSizeY,BGR(133,133,133));
			pImage->Box(m_iStarX+4,0,1,m_iWndSizeY,BGR( 88, 88, 88));
			pImage->Box(m_iStarX+5,0,1,m_iWndSizeY,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iStarX,0,6,m_iWndSizeY);

			pImage->Box(m_iWndSizeX-6-m_iStarX+0,0,1,m_iWndSizeY,BGR(222,222,222));
			pImage->Box(m_iWndSizeX-6-m_iStarX+1,0,1,m_iWndSizeY,BGR(188,188,188));
			pImage->Box(m_iWndSizeX-6-m_iStarX+2,0,2,m_iWndSizeY,BGR(133,133,133));
			pImage->Box(m_iWndSizeX-6-m_iStarX+4,0,1,m_iWndSizeY,BGR( 88, 88, 88));
			pImage->Box(m_iWndSizeX-6-m_iStarX+5,0,1,m_iWndSizeY,BGR( 44, 44, 44));

			m_cBitmapWnd.InvalidateRect(m_iWndSizeX-6-m_iStarX,0,6,m_iWndSizeY);
			}

		m_aStars[60] = m_aBgNum[0];
		m_aStars[61] = m_aBgNum[1];


		if(m_iDrawState)									// Ist der Zeichenmodus aktiv
			{
			if(m_iDrawState==1)
				{
				m_iPolyStep = m_iPolyCount;					// Alles aufdecken mit Gitterlinien
				}
			else{
			   	m_iPolyStep = m_iDrawState-3;
				}

			if(m_iPolyStep>m_iPolyCount)
				{
				m_iPolyStep = m_iPolyCount;
				}
			}


		if(m_iPolyNow!=m_iPolyStep)							// Hat sich der Aufdeckungsgrad gendert
			{
			iWidth = m_iWndSizeX-(m_iStarX+FRAME_SIZE)*2;
			iHeigh = m_iWndSizeY-TEXT_LINE;

			pImage->Box(m_iStarX+FRAME_SIZE,0,iWidth,m_iWndSizeY,BGR(0,0,0));

			iSizeX = m_sPicImage.Width ();
			iSizeY = m_sPicImage.Height();

			if(iSizeX<=0)iSizeX=1;
			if(iSizeY<=0)iSizeY=1;

			if(iWidth*iSizeY<iHeigh*iSizeX)					// Skalierung berechnen
				{
				iSizeY = (iSizeY*iWidth)/iSizeX;
				iSizeX = iWidth;
				}
			else{
				iSizeX = (iSizeX*iHeigh)/iSizeY;
				iSizeY = iHeigh;
				}

															// Passt die Auflsung des Bildes
			if(iSizeX^m_sPicImage.Width() || iSizeY^m_sPicImage.Height())
				{
				m_sPicPoly.Stretch(m_sPicImage,iSizeX,iSizeY,1);
				}
			else{
				m_sPicPoly = m_sPicImage;
				}


			if(m_iPolyStep<0)								// Ist das gesmates Bild verdecken
				{
				if(m_bColorMode && m_iDrawState!=2)
						uColor=BGR(0, 0,0);
				else	uColor=BGR(8,24,8);

				m_sPicPoly.Box(0,0,m_sPicPoly.Width(),m_sPicPoly.Height(),uColor);

				iNum = m_iPolyCount;
				}
			else{
				iNum = m_iPolyCount-m_iPolyStep;
				}

			iPicX = m_sPicImage.Width();
			iPicY = m_sPicImage.Height();

			if(iPicX<=0)iPicX=1;
			if(iPicY<=0)iPicY=1;


			for(iPos=0;iPos<iNum;iPos++)					// Alle Polygone in temorren Bild zeichnen
				{
				iAll  = m_aPolySize[iPos];

				if(iAll<3)continue;

				iOffX = 0;
				iOffY = 0;

				for(iOff=0;iOff<iAll;iOff++)				// Skaliertes Polygon holen
					{
					aPoly[iOff*2+0]  = m_aPolygons[MAX_PT*2*iPos+iOff*2+0];
					aPoly[iOff*2+0] *= iSizeX;
					aPoly[iOff*2+0] /= iPicX;

					aPoly[iOff*2+1]  = m_aPolygons[MAX_PT*2*iPos+iOff*2+1];
					aPoly[iOff*2+1] *= iSizeY;
					aPoly[iOff*2+1] /= iPicY;

					iOffX += aPoly[iOff*2+0];
					iOffY += aPoly[iOff*2+1];
					}

				if(m_bColorMode && m_iDrawState!=2)			// Farbe fr Polygon
					{
					uColor=BGR(0,0,0);
					}
				else{
					iId = m_aPolyId[iPos];
					uColor=BGR((iId&1)*32+(iId&8)*8,(iId/4)*16+32,(iId&2)*16+(iId&8)*8);
					}

				m_sPicPoly.Polygon(aPoly,iAll,uColor);

				if(m_iPolyInfo)	 							// Poligon Infos ausgeben
					{
					char	cInfo[32];

					iOffX /= iAll;
					iOffY /= iAll;

					sprintf(cInfo,"%i. %s",m_iPolyCount-iPos,(LPCTSTR)m_aPolyName[iPos]);

					m_sPicPoly.SetFont(m_aFontS);
					m_sPicPoly.SetAlign(1);
					m_sPicPoly.SetPixelFunction(TEXT_NONE,0,1);
					m_sPicPoly.SetPixelFunction(TEXT_SMOTH,BGR(255,255,255),0);
					m_sPicPoly.Print(iOffX,iOffY,cInfo);
					}
				}


			iAddX = (iWidth-iSizeX)/2;
			iAddY = (iHeigh-iSizeY)/2;
															// Das Bild mit Polygonen am Fenster ausgeben
			pImage->Put(m_sPicPoly,m_iStarX+FRAME_SIZE+iAddX,TEXT_LINE+iAddY);

			m_cBitmapWnd.InvalidateRect(m_iStarX+FRAME_SIZE,TEXT_LINE,iWidth,iHeigh);
			m_iPolyNow = m_iPolyStep;
			}

		if(m_iTextLine)										// Infotext ausgeben
			{
			m_iTextLine = 0;

			iWidth = m_iWndSizeX-(m_iStarX+FRAME_SIZE)*2;

			pImage->Box(m_iStarX+FRAME_SIZE,0, iWidth ,TEXT_LINE-6,BGR(  0,  0,  0));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+0,iWidth,1,BGR(222,222,222));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+1,iWidth,1,BGR(188,188,188));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+2,iWidth,2,BGR(133,133,133));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+4,iWidth,1,BGR( 88, 88, 88));
			pImage->Box(m_iStarX+FRAME_SIZE,TEXT_LINE-6+5,iWidth,1,BGR( 44, 44, 44));

			pImage->SetFont(m_aFont);
			pImage->SetAlign(1);
			pImage->SetPixelFunction(TEXT_NONE ,0,1);
			pImage->SetPixelFunction(TEXT_SMOTH,BGR(0,255,0),0);
			iPixel = pImage->Print(0,BI_TETXSIZE,m_aPicOut);

			if(iPixel>iWidth-8)								// Kleineren Font benutzen
				{
				pImage->SetFont(m_aFontX);
				iPixel = pImage->Print(0,BI_TETXSIZE,m_aPicOut);

				if(iPixel>iWidth-8)
					{
					pImage->SetFont(m_aFontS);
					pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-20)/2,m_aPicOut);
					}
				else{
					pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-32)/2,m_aPicOut);
					}
				}
			else{
				pImage->Print(m_iStarX+FRAME_SIZE+iWidth/2,(TEXT_LINE-40)/2,m_aPicOut);
				}


			m_cBitmapWnd.InvalidateRect(m_iStarX+FRAME_SIZE,0,iWidth,TEXT_LINE);
			}

		bLocked = FALSE;

		return;
		}

	CView::OnTimer(nIdEvent);
}


//*****************************************************************************
//*
//*		ComThread
//*
//*****************************************************************************
DWORD WINAPI CGameDalliView::ComThread(LPVOID pParam)
{
CGameDalliView *pThis=(CGameDalliView*)pParam;
char			aData[33];
static int		aLastPush[8];
int				iHandle=-1;
int				iValue;
int				iFlag;
int				iPort;
int				iDiff;
int				iPin;
int				iPos;
int				iOff;


	iPort = -1;
	iPos  =  0;

	while(!pThis->m_iStop)
		{
		if(iPort!=pThis->m_iPort || !ComCheckPort(iHandle))
			{
			ComClose(iHandle);
			iPort   = pThis->m_iPort;
			iHandle = ComOpen(iPort,9600);
			}

		if(iHandle<0)
			{
			Sleep(200);
			continue;
			}

		for(iOff=0;iOff<iPos;iOff++)
			{
			if(!strwchar(aData[iOff],0x00040001))
				{
				continue;
				}

			if(iOff+1<iPos)
				{
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D')continue;
				}

			break;
			}

		if(iOff>0)
			{
			iPos -= iOff;
			memmove(aData,aData+iOff,iPos);
			}

		aData[iPos] = 0;
		iFlag		= 0;

		while(iPos>=3)
			{
			iOff = strwlen(aData+2,0x00040001);

			if(iOff>8)
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}


			if(iOff<8)
				{
				if(iOff+2==iPos)break;

				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			if(iOff==8 && iPos==10)
				{
				break;
				}

			if(iOff==8 && aData[10]!='\r' && aData[10]!='\n')
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			iPin = aData[0]-'0';
			iValue = GetTickCount();

			if(aData[1]=='D' && iPin<8)
				{
				   iDiff = iValue-aLastPush[iPin];
				if(iDiff<0 || iDiff>100)
					{
					aLastPush[iPin] = iValue;

					switch(iPin)
						{
					case 0:	pThis->Stop(0);
							break;

					case 1:	pThis->Stop(1);
							break;

					case 2:	pThis->PostMessage(WM_COMMAND,ID_START);
							break;

					case 3:	pThis->PostMessage(WM_COMMAND,ID_RESET);
							break;

					case 4:	pThis->PostMessage(WM_COMMAND,ID_STARSUB1);
							break;

					case 5:	pThis->PostMessage(WM_COMMAND,ID_STARADD1);
							break;

					case 6:	pThis->PostMessage(WM_COMMAND,ID_STARSUB2);
							break;

					case 7:	pThis->PostMessage(WM_COMMAND,ID_STARADD2);
							break;
						}

					/*
					if(iPin==4)
						{
						iDiff = iValue-pThis->m_uLastZoom;

						if(iDiff<0 || iDiff>100)
							{
							pThis->m_uLastZoom = iValue;
							pThis->PostMessage(WM_COMMAND,ID_ZOOM);
							}
						}
					*/
					}
				}

			if(aData[11]!='\n')iOff++;

			iOff += 2;
			iPos -= iOff;

			if(iPos<0 || iPos>32)iPos=0;

			memmove(aData,aData+iOff,iPos);

			if(iPos>=3)
				{
				if(aData[0]<'0'){iFlag=1;break;}
				if(aData[0]>'7'){iFlag=1;break;}
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D'){iFlag=1;break;}
				}
			}

		if(iFlag)continue;


		ComWaitUntilResv(iHandle,100);
		iOff = ComGetReadCount(iHandle);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		if(iPos+iOff>32)iOff=32-iPos;
		iOff = ComRead(iHandle,aData+iPos,iOff);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		iPos += iOff;
		aData[iPos] =0;
		}


	ComClose(iHandle);
	pThis->m_iDone = 1;


return 0;
}

//*****************************************************************************
//*
//*		TransMultiply
//*
//*****************************************************************************
//	Mutipliziert zwei pseudo 3x3 Matrizen mit einander
//		a b c
//	M = d e f
//		0 0 1
void CGameDalliView::TransMultiply(double *pMatrix1,double *pMatrix2,double *pOut)
{

	pOut[0] = pMatrix1[0]*pMatrix2[0] + pMatrix1[1]*pMatrix2[2];
	pOut[1] = pMatrix1[0]*pMatrix2[1] + pMatrix1[1]*pMatrix2[3];
	pOut[4] = pMatrix1[0]*pMatrix2[4] + pMatrix1[1]*pMatrix2[5] + pMatrix1[4];

	pOut[2] = pMatrix1[2]*pMatrix2[0] + pMatrix1[3]*pMatrix2[2];
	pOut[3] = pMatrix1[2]*pMatrix2[1] + pMatrix1[3]*pMatrix2[3];
	pOut[5] = pMatrix1[2]*pMatrix2[4] + pMatrix1[3]*pMatrix2[5] + pMatrix1[5];

}

//*****************************************************************************
//*
//*		TransMultiply
//*
//*****************************************************************************
//	Mutipliziert zwei pseudo 3x3 Matrizen mit einander
//		a b c
//	M = d e f
//		0 0 1
void CGameDalliView::TransMultiply(double *pMatrix,double *pOut)
{
double		aOld[6];


	memcpy(aOld,pOut,sizeof(aOld));
	TransMultiply(aOld,pMatrix,pOut);

}

//*****************************************************************************
//*
//*		TransPoint
//*
//*****************************************************************************
void CGameDalliView::TransPoint(double *pMatrix,double *pPoint)
{
double		dPosX;
double		dPosY;


	dPosX	  = pPoint[0];
	dPosY	  = pPoint[1];
	pPoint[0] = pMatrix[0]*dPosX + pMatrix[1]*dPosY+pMatrix[4];
	pPoint[1] = pMatrix[2]*dPosX + pMatrix[3]*dPosY+pMatrix[5];

}

//*****************************************************************************
//*
//*		TransPoint
//*
//*****************************************************************************
//	Transformiert einen Punkt via Transformationsmatrix n=M*p
//	pNew		: Hier wird der neue Punkt gespeichert
//	pMatrix		: Zeiger auf die Transformationsmatrix
//	pPoint		: Zeiger auf Punkt.
void CGameDalliView::TransPoint(const double *pMatrix,const double *pPoint,double *pNew)
{
double	dPosX;
double	dPosY;


	dPosX	= pPoint[0];
	dPosY	= pPoint[1];

	pNew[0] = pMatrix[0]*dPosX + pMatrix[1]*dPosY+pMatrix[4];
	pNew[1] = pMatrix[2]*dPosX + pMatrix[3]*dPosY+pMatrix[5];

}


//*****************************************************************************
//*
//*		GetArray
//*
//*****************************************************************************
//	Holt ein Werte-Array aus einem Text.
//	pText		: Zeiger auf den Text
//	pArray		: Zeiger auf das Werte-Array
//	iMax		: Gre des Werte-Arrays
//	Ergibt die Anzahl der gefundenen Werte.
int CGameDalliView::GetArray(const char *pText,double *pArray,int iMax)
{
int		iLen;
int		iPos;
int		iNum;


	for(iPos=0;iPos<iMax;iPos++)						// Werte einlesen
		{
		pArray[iPos] = strtof(pText,&iLen);
		if(!iLen)break;
		pText += iLen;
		pText += strwlen(pText,0xE0);
		if(*pText==',')pText++;
		}

	for(iNum=iPos;iNum<iMax;iNum++)						// Restliche mit 0 fllen
		{
		pArray[iNum] = 0;
		}


return iPos;
}

//*****************************************************************************
//*
//*		CheckPoint
//*
//*****************************************************************************
int	CGameDalliView::CheckPoint(int *pCenter,int *pLast,int *pDraw,int *pNext)
{
double		dDiffX;
double		dDiffY;
double		dDelta;
double		dDiff;
double		dPhiL;
double		dPhiD;
double		dPhiN;



	dDiffX	= pLast[0]-pCenter[0];
	dDiffY	= pLast[1]-pCenter[1];
	dPhiL	= atan2(dDiffY,dDiffX);

	dDiffX	= pDraw[0]-pCenter[0];
	dDiffY	= pDraw[1]-pCenter[1];
	dPhiD	= atan2(dDiffY,dDiffX);

	dDiffX	= pNext[0]-pCenter[0];
	dDiffY	= pNext[1]-pCenter[1];
	dPhiN	= atan2(dDiffY,dDiffX);

	dDelta	= dPhiL-dPhiD;
	dDiff	= dPhiL-dPhiN;

	if(dDelta> PI)dDelta-=PI*2;
	if(dDelta<-PI)dDelta+=PI*2;
	if(dDiff > PI)dDiff -=PI*2;
	if(dDiff <-PI)dDiff +=PI*2;

	if(dDelta>=0)
		{
		if(dDiff>=dDelta)return 0;
		if(dDiff<=0     )return 0;
		}
	else{
		if(dDiff<=dDelta)return 0;
		if(dDiff>=0     )return 0;
		}


return 1;
}

//*****************************************************************************
//*
//*		DecodeTransform
//*
//*****************************************************************************
//	Dekotiert eine SVG-Transformation
int CGameDalliView::DecodeTransform(const char *pText,double *pTrans)
{
double		aMatrix[6];
double		aList[6];
const char *pStop;
int			iNum;
int			iOk;



	iOk = 0;

	pTrans[0]	= 1.0;
	pTrans[1]	= 0.0;
	pTrans[2]	= 0.0;
	pTrans[3]	= 1.0;
	pTrans[4]	= 0.0;
	pTrans[5]	= 0.0;

	if(*pText=='"')
		{
		pText++;
		pStop = pText+strchar(pText,'"');
		}
	else{
		pStop = pText+4096;
		}

	while(*pText && pText<pStop)
		{
		pText += strwlen(pText,0xE0);

		if(!memicmp(pText,"matrix(",7))
			{
			pText  += 7;
			iNum	= GetArray(pText,aList,6);

			if(iNum==6)
				{
				aMatrix[0]	=  aList[0];
				aMatrix[1]	=  aList[2];
				aMatrix[2]	=  aList[1];
				aMatrix[3]	=  aList[3];
				aMatrix[4]	=  aList[4];
				aMatrix[5]	=  aList[5];

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}
		else if(!memicmp(pText,"translate(",10))
			{
			pText  += 10;
			iNum	= GetArray(pText,aList,2);

			if(iNum>=1)
				{
				if(iNum<=1)aList[1]=0;

				aMatrix[0]	=  1.0;
				aMatrix[1]	=  0.0;
				aMatrix[2]	=  0.0;
				aMatrix[3]	=  1.0;
				aMatrix[4]	=  aList[0];
				aMatrix[5]	=  aList[1];

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}
		else if(!memicmp(pText,"scale(",6))
			{
			pText  += 6;
			iNum	= GetArray(pText,aList,2);

			if(iNum>=1)
				{
				if(iNum==1)aList[1]=aList[0];

				aMatrix[0]	=  aList[0];
				aMatrix[1]	=  0.0;
				aMatrix[2]	=  0.0;
				aMatrix[3]	=  aList[1];
				aMatrix[4]	=  0.0;
				aMatrix[5]	=  0.0;

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}
		else if(!memicmp(pText,"rotate(",7))
			{
			pText  += 7;
			iNum	= GetArray(pText,aList,3);

			if(iNum>1)
				{
				aMatrix[0]	=  1.0;
				aMatrix[1]	=  0.0;
				aMatrix[2]	=  0.0;
				aMatrix[3]	=  1.0;
				aMatrix[4]	=  aList[1];
				aMatrix[5]	=  aList[2];

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}

			if(iNum>=1)
				{
				aList[0]   *=  PI/180.0;
				aMatrix[0]	=  cos(aList[0]);
				aMatrix[1]	= -sin(aList[0]);
				aMatrix[2]	=  sin(aList[0]);
				aMatrix[3]	=  cos(aList[0]);
				aMatrix[4]	=  aList[1];
				aMatrix[5]	=  aList[2];

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}

			if(iNum>1)
				{
				aMatrix[0]	=  1.0;
				aMatrix[1]	=  0.0;
				aMatrix[2]	=  0.0;
				aMatrix[3]	=  1.0;
				aMatrix[4]	= -aList[1];
				aMatrix[5]	= -aList[2];

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}
		else if(!memicmp(pText,"skewX(",6))
			{
			pText  += 6;
			iNum	= GetArray(pText,aList,1);

			if(iNum>=1)
				{
				if(iNum==1)aList[1]=aList[0];

				aMatrix[0]	=  1.0;
				aMatrix[1]	=  0.0;
				aMatrix[2]	=  tan(aList[0]);
				aMatrix[3]	=  1.0;
				aMatrix[4]	=  0.0;
				aMatrix[5]	=  0.0;

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}
		else if(!memicmp(pText,"skewY(",6))
			{
			pText  += 6;
			iNum	= GetArray(pText,aList,1);

			if(iNum>=1)
				{
				if(iNum==1)aList[1]=aList[0];

				aMatrix[0]	=  1.0;
				aMatrix[1]	=  tan(aList[0]);
				aMatrix[2]	=  0.0;
				aMatrix[3]	=  1.0;
				aMatrix[4]	=  0.0;
				aMatrix[5]	=  0.0;

				TransMultiply(aMatrix,pTrans);
				iOk++;
				}
			}

		pText += strlchar(pText,')');
		}


return iOk;
}

//*****************************************************************************
//*
//*		DecodePath
//*
//*****************************************************************************
int	CGameDalliView::DecodePath(const char *pText,double *pItems,int iMax,int iEnd)
{
double		dStartX;
double		dStartY;
double		dEndX;
double		dEndY;
double		dPosX;
double		dPosY;
double		dValX;
double		dValY;
int			iCount;
int			iSize;
int			iSign;
int			iLast;
int			iOff;
int			iLen;


	iLast	 = 0;
	iCount	 = 0;
	dPosX	 = 0.0;
	dPosY	 = 0.0;
	dStartX	 = 0.0;
	dStartY	 = 0.0;


	   iOff = strlifind(pText,"d=\"",iEnd);
	if(iOff<0)return 0;


	iOff  += 3;
	iSize  = strchar(pText+iOff,'"',iEnd-iOff);
	iSize += iOff;


	while(iOff<iSize)
		{
		if(iCount*2+1>iMax)break;

		iOff	+= strwlen(pText+iOff,0xE0);
		iSign	 = pText[iOff];

		if(strwchar(iSign,0x02000201))							// Kein Kommando
			{
			iOff -= 1;
			iSign = iLast;
			}
		else{
			iLast = iSign;
			}

		switch(iSign)
			{
		case 'H':												// LineTo horizontal
		case 'h':	iOff   += 1;
					dValX   = strtof(pText+iOff,&iLen);
					iOff   += iLen;

					if(iSign>='a')								// relativ
						{
						dEndX  = dValX+dPosX;
						dEndY  = dPosY;
						}
					else{										// global
						dEndX  = dValX;
						dEndY  = dPosY;
						}

					goto Line;

		case 'V':												// LineTo vertical
		case 'v':	iOff   += 1;
					dValY   = strtof(pText+iOff,&iLen);
					iOff   += iLen;

					if(iSign>='a')								// relativ
						{
						dEndX  = dPosX;
						dEndY  = dValY+dPosY;
						}
					else{										// global
						dEndX  = dPosX;
						dEndY  = dValY;
						}
																// REM AZ Bzier Kurve nur als Linie imlementiert
					goto Line;
		case 'L':												// LineTo
		case 'l':	iOff   += 1;
					dValX   = strtof(pText+iOff,&iLen);
					iOff   += iLen;
					iOff   += strwlen(pText+iOff,0x10E0);
					dValY   = strtof(pText+iOff,&iLen);
					iOff   += iLen;

					if(iSign>='a')								// relativ
						{
						dEndX  = dValX+dPosX;
						dEndY  = dValY+dPosY;
						}
					else{										// global
						dEndX  = dValX;
						dEndY  = dValY;
						}
		Line:
					pItems[iCount*2+0]	=  dEndX;
					pItems[iCount*2+1]	=  dEndY;
					iCount++;

					dPosX	= dEndX;
					dPosY	= dEndY;

					break;

		case 'M':												// MoveTo
		case 'm':	iOff   += 1;
					dValX   = strtof(pText+iOff,&iLen);
					iOff   += iLen;
					iOff   += strwlen(pText+iOff,0x10E0);
					dValY   = strtof(pText+iOff,&iLen);
					iOff   += iLen;

					if(iSign>='a')								// relativ
						{
						dPosX += dValX;
						dPosY += dValY;
						}
					else{										// global
						dPosX  = dValX;
						dPosY  = dValY;
						}

					pItems[iCount*2+0]	=  dPosX;
					pItems[iCount*2+1]	=  dPosY;
					iCount++;

					dStartX	= dPosX;
					dStartY	= dPosY;

					break;

		case 'Z':												// Linie schliesen
		case 'z':	iOff	= iSize;
					break;

		case '"':												// Ende
					iOff	= iSize;
					break;

		default:	iOff	= iSize;
					iCount	= 0;
					break;

			}
		}







return iCount;
}

//*****************************************************************************
//*
//*		OnUseImage?
//*
//*****************************************************************************
void CGameDalliView::OnUseImageA(){UseImage(2);}
void CGameDalliView::OnUseImageB(){UseImage(1);}
void CGameDalliView::OnUseImageC(){UseImage(0);}
void CGameDalliView::OnUseImageD(){UseImage(3);}


//*****************************************************************************
//*
//*		UseImage
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iMode		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGameDalliView::UseImage(int iMode)
{

	m_iStarSize = iMode;
	SelectStar(m_iStarSize);

	memset(m_aStars,0xFF,sizeof(m_aStars));
	m_uHgOk		  = 0xFF;
	m_iPolyNow	  = -2;
	m_iTextLine	  = 1;

	m_cBitmapWnd.RedrawWindow();

}

//*****************************************************************************
//*
//*		SelectStar
//*
//*****************************************************************************
//	Eine neue Gre der Sterne einstellen
//	iStar		: Gre der Sterne (0=gro 1=mittel 2=klein 3=Zwei-Reihen)
void CGameDalliView::SelectStar(int iStar)
{

	switch(iStar)
		{
	case 3:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS*3+(MAX_POINTS+1&1);
			m_iStarX		= 136;
			m_iStarY		= 68;
			m_iStarRows		= 2;
			break;

	case 2:	m_sStarImg		= m_sStarImg3;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 68;
			m_iStarY		= 68;
			m_iStarRows		= 1;
			break;

	case 1:	m_sStarImg		= m_sStarImg2;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 102;
			m_iStarY		= 102;
			m_iStarRows		= 1;
			break;

	default:m_sStarImg		= m_sStarImg1;
			m_iStarMax		= MAX_POINTS;
			m_iStarX		= 136;
			m_iStarY		= 136;
			m_iStarRows		= 1;
			break;
		}

}

//*****************************************************************************
//*
//*		LoadGame
//*
//*****************************************************************************
int CGameDalliView::LoadGame(int iIndex)
{
char		cTemp[64];
char		cBuffer[0x10000];
double		aPath[MAX_PT*2];
double		aTransform[6*32];
double		aMatrix[6];
double		aPointA[2];
double		aPointB[2];
double		aMinMax[4];
double		dDeltaX;
double		dDeltaY;
double	   *pMatrix;
LPCTSTR		pName1;
LPCTSTR		pName2;
CString		sPath;
int			iLevel;
int			iNone;
int			iPos;
int			iLen;
int			iOff;
int			iIdx;
int			iSub;


	m_iPolyNow		=-2;
	m_iPolyStep		=-1;
	m_iPolyCount	= 0;
	m_bChanged		= 0;

	sprintf(cBuffer,"\\Game%03i\\Pic.png",iIndex);

	sPath  = m_sPicPath;
	sPath += cBuffer;

	if(ImageLoader(sPath,&m_sPicImage))
		{
		return 0;
		}

	sprintf(cBuffer,"\\Game%03i\\Pic.txt",iIndex);

	sPath  = m_sPicPath;
	sPath += cBuffer;

	if(LoadMemory(sPath,cBuffer,sizeof(cBuffer))<=0)
		{
		return 0;
		}

	iLen = strcwlen(cBuffer,0x40);


	if(cBuffer[iLen])
		{
		iPos  = iLen+1;
		iPos += strwlen (cBuffer+iPos,0x40);
		cBuffer[iLen] = 0;
		iLen  = strcwlen(cBuffer+iPos,0x40);
		cBuffer[iPos+iLen] = 0;
		strlcpy(m_aPicInfo,cBuffer+iPos,sizeof(m_aPicInfo));
		}
	else{
		m_aPicInfo[0] = 0;
		}

	strlcpy(m_aPicText,cBuffer,sizeof(m_aPicText));

	sprintf(cBuffer,"\\Game%03i\\Pic.svg",iIndex);

	sPath  = m_sPicPath;
	sPath += cBuffer;

	if(LoadMemory(sPath,cBuffer,sizeof(cBuffer))<=0)
		{
		return 0;
		}

	strreplace(cBuffer,'\n',' ');
	strreplace(cBuffer,'\r',' ');
	strreplace(cBuffer,'\t',' ');

	   iPos = strifind(cBuffer,"<svg");
	if(iPos<=0)return 0;

	iPos += strchar(cBuffer+iPos,'>');

	aPointA[0]		= 0;
	aPointA[1]		= 0;
	aPointB[0]		= 0;
	aPointB[1]		= 0;
	aTransform[0]	= 1;
	aTransform[1]	= 0;
	aTransform[2]	= 0;
	aTransform[3]	= 1;
	aTransform[4]	= 0;
	aTransform[5]	= 0;
	iLevel			= 0;
	iNone			= 0;

	for(;;iPos+=iLen)
		{
		iPos += strchar(cBuffer+iPos,'<');
		if(cBuffer[iPos]==0)break;
		iLen  = strchar(cBuffer+iPos,'>');

															// Gruppe beginnen
		if(!memicmp(cBuffer+iPos,"<g",2) && !strwchar(cBuffer[iPos+2],0x0F))
			{
			if(iLevel>=31)
				{
				iNone++;
				continue;
				}

			iLevel++;
			memcpy(aTransform+iLevel*6,aTransform+(iLevel-1)*6,sizeof(double)*6);

			iOff  = strlifind(cBuffer+iPos,"transform=",iLen);

			if(iOff>0 && DecodeTransform(cBuffer+iPos+iOff,aMatrix))
				{
				TransMultiply(aMatrix,aTransform+iLevel*6);
				}

			continue;
			}
															// Gruppe aufheben
		if(!memicmp(cBuffer+iPos,"</g",3) && !strwchar(cBuffer[iPos+3],0x0F))
			{
			if(iNone>0)
				{
				iNone--;
				continue;
				}

			if(iLevel>0)
				{
				iLevel--;
				continue;
				}
			}



		iOff  = strlifind(cBuffer+iPos,"transform=",iLen);
		iSub  = 0;

		if(iOff>0)
			{
			if(DecodeTransform(cBuffer+iPos+iOff+10,aMatrix))
				{
				iSub = 1;
				iLevel++;
				TransMultiply(aTransform+(iLevel-1)*6,aMatrix,aTransform+iLevel*6);
				}
			}


		pMatrix = aTransform+iLevel*6;

																// Image gefunden
		if(!memicmp(cBuffer+iPos,"<image",6) && !strwchar(cBuffer[iPos+6],0x0F))
			{
			   iOff = strlifind(cBuffer+iPos,"x=",iLen);
			if(iOff<0)return 0;
				{
				iOff += 2;
				if(cBuffer[iPos+iOff]=='"')iOff++;
				aPointA[0] = strtof(cBuffer+iPos+iOff);
				}

			   iOff = strlifind(cBuffer+iPos,"y=",iLen);
			if(iOff<0)return 0;
				{
				iOff += 2;
				if(cBuffer[iPos+iOff]=='"')iOff++;
				aPointA[1] = strtof(cBuffer+iPos+iOff);
				}

			   iOff = strlifind(cBuffer+iPos,"width=",iLen);
			if(iOff<0)return 0;
				{
				iOff += 6;
				if(cBuffer[iPos+iOff]=='"')iOff++;
				aPointB[0] = strtof(cBuffer+iPos+iOff)+aPointA[0];
				}

			   iOff = strlifind(cBuffer+iPos,"height=",iLen);
			if(iOff<0)return 0;
				{
				iOff += 7;
				if(cBuffer[iPos+iOff]=='"')iOff++;
				aPointB[1] = strtof(cBuffer+iPos+iOff)+aPointA[1];
				}

			TransPoint(pMatrix,aPointA);
			TransPoint(pMatrix,aPointB);

			iLevel -= iSub;
			continue;
			}


		if(!memicmp(cBuffer+iPos,"<path",5) && !strwchar(cBuffer[iPos+5],0x0F))
			{
			if(m_iPolyCount>=MAX_POLY)break;

			   iIdx = DecodePath(cBuffer+iPos,aPath,256/2,iLen);
			if(iIdx<=2)
				{
				iLevel -= iSub;
				continue;
				}

			   iOff = strlifind(cBuffer+iPos,"class=",iLen);
			if(iOff>0)
				{
				strgetstr(cTemp,cBuffer+iPos+iOff+6,sizeof(cTemp));
				m_aPolyName[m_iPolyCount] = cTemp;
				}
			else{
				m_aPolyName[m_iPolyCount] = "";
				}

			TransPoint(pMatrix,aPath);
			aMinMax[0] = aPath[0];
			aMinMax[1] = aPath[1];
			aMinMax[2] = aPath[0];
			aMinMax[3] = aPath[1];

			for(iOff=1;iOff<iIdx;iOff++)
				{
				TransPoint(pMatrix,aPath+iOff*2);

				if(aMinMax[0]>aPath[iOff*2+0])aMinMax[0]=aPath[iOff*2+0];
				if(aMinMax[1]>aPath[iOff*2+1])aMinMax[1]=aPath[iOff*2+1];
				if(aMinMax[2]<aPath[iOff*2+0])aMinMax[2]=aPath[iOff*2+0];
				if(aMinMax[3]<aPath[iOff*2+1])aMinMax[3]=aPath[iOff*2+1];
				}

			iLevel -= iSub;

			aMinMax[2] -= aMinMax[0];
			aMinMax[3] -= aMinMax[1];
			aMinMax[2] *= 0.00001;
			aMinMax[3] *= 0.00001;

			while(iIdx>=3)
				{
				if(aPath[0]-aMinMax[2]>aPath[iIdx*2-2])break;
				if(aPath[0]+aMinMax[2]<aPath[iIdx*2-2])break;
				if(aPath[1]-aMinMax[3]>aPath[iIdx*2-1])break;
				if(aPath[1]+aMinMax[3]<aPath[iIdx*2-1])break;
				iIdx--;
				}

			if(iIdx<=2)
				{
				continue;
				}

			m_aPolySize[m_iPolyCount] = iIdx;

			dDeltaX	= aPointB[0]-aPointA[0];
			dDeltaY	= aPointB[1]-aPointA[1];

			if(dDeltaX==0.0)dDeltaX=1.0;
			if(dDeltaY==0.0)dDeltaY=1.0;

			aMatrix[0]	= m_sPicImage.Width ();
			aMatrix[1]	= 0;
			aMatrix[2]	= 0;
			aMatrix[3]	= m_sPicImage.Height();
			aMatrix[0] /= dDeltaX;
			aMatrix[3] /= dDeltaY;
			aMatrix[4]	=-aPointA[0]*aMatrix[0];
			aMatrix[5]	=-aPointA[1]*aMatrix[3];

			for(iOff=0;iOff<iIdx;iOff++)
				{
				TransPoint(aMatrix,aPath+iOff*2);
				m_aPolygons[m_iPolyCount*MAX_PT*2+iOff*2+0] = (int)aPath[iOff*2+0];
				m_aPolygons[m_iPolyCount*MAX_PT*2+iOff*2+1] = (int)aPath[iOff*2+1];
				}

			m_iPolyCount++;

			continue;
			}
		}


	pName1 = m_aPolyName[0];
	iLen   = strchar(pName1,' ');

	if(pName1[iLen]==' ')
		{
		iLen++;

		for(iIdx=1;iIdx<m_iPolyCount;iIdx++)
			{
			pName2 = m_aPolyName[iIdx];
			if(memcmp(pName1,pName2,iLen))break;
			}

		if(iIdx>=m_iPolyCount)
			{
			for(iIdx=0;iIdx<m_iPolyCount;iIdx++)
				{
				pName1			  = m_aPolyName[iIdx];
				m_aPolyName[iIdx] = pName1+iLen;
				}
			}
		}


return 1;
}

//*****************************************************************************
//*
//*		OnDrawMode
//*
//*****************************************************************************
//	Der Zeichenmodus wurde verndert
void CGameDalliView::OnDrawMode(UINT uId)
{
int		iOld;


	iOld		  = m_iDrawState;
	uId			 -= ID_DRAWMODE;
	m_iDrawState  = uId;

	if(iOld==m_iDrawState)return;

	AudioPause(m_iDrawState);

	m_uStartTick  = GetTickCount();
	OnTimer(IDC_UPDATE);

	if(m_iDrawState==0)
		{
		m_iPolyStep = -1;
		}

	if(iOld==1 || m_iDrawState==1)
		{
		RedrawWindow();
		}

	if(m_uGameNumber==0 && m_iDrawState>0)
		{
		OnStart();
		}

}

//*****************************************************************************
//*
//*		RedrawPoints
//*
//*****************************************************************************
//	Alle Punkte eines Polygons neuzeichnen
void CGameDalliView::RedrawPoints(int iPolygon)
{
CRect	sRect;
int		iPos;


	if(iPolygon<0 || iPolygon>=m_iPolyCount)
		{
		return;
		}

	for(iPos=m_iDrawItems-1;iPos>=0;iPos--)
		{
		if(iPolygon!=m_aDrawPoly[iPos])continue;

		sRect.left	 = m_aDrawX[iPos]-5;
		sRect.right	 = m_aDrawX[iPos]+5;
		sRect.top	 = m_aDrawY[iPos]-5;
		sRect.bottom = m_aDrawY[iPos]+5;

		InvalidateRect(&sRect);
		}

}

//*****************************************************************************
//*
//*		DrawMinMax
//*
//*****************************************************************************
//	Min-Max Werte von einem Punkt holen mit norherigen und nchsten Punkt.
void CGameDalliView::DrawMinMax(int iUsed,int &iMinX,int &iMinY,int &iMaxX,int &iMaxY,int iSet)
{
int		iBase;
int		iStep;
int		iPoly;
int		iSize;


	if(iSet)
		{
		iMinX	= m_aDrawX[iUsed];
		iMaxX	= m_aDrawX[iUsed];
		iMinY	= m_aDrawY[iUsed];
		iMaxY	= m_aDrawY[iUsed];
		}
	else{
		if(iMinX>m_aDrawX[iUsed])iMinX=m_aDrawX[iUsed];
		if(iMaxX<m_aDrawX[iUsed])iMaxX=m_aDrawX[iUsed];
		if(iMinY>m_aDrawY[iUsed])iMinY=m_aDrawY[iUsed];
		if(iMaxY<m_aDrawY[iUsed])iMaxY=m_aDrawY[iUsed];
		}

	iPoly	= m_aDrawPoly[iUsed];
	iStep	= m_aDrawStep[iUsed];
	iSize	= m_aPolySize[iPoly];
	iBase	= iUsed-iStep;

	iUsed	= iBase+(iStep+iSize-1)%iSize;

	if(iMinX>m_aDrawX[iUsed])iMinX=m_aDrawX[iUsed];
	if(iMaxX<m_aDrawX[iUsed])iMaxX=m_aDrawX[iUsed];
	if(iMinY>m_aDrawY[iUsed])iMinY=m_aDrawY[iUsed];
	if(iMaxY<m_aDrawY[iUsed])iMaxY=m_aDrawY[iUsed];

	iUsed	= iBase+(iStep+1)%iSize;

	if(iMinX>m_aDrawX[iUsed])iMinX=m_aDrawX[iUsed];
	if(iMaxX<m_aDrawX[iUsed])iMaxX=m_aDrawX[iUsed];
	if(iMinY>m_aDrawY[iUsed])iMinY=m_aDrawY[iUsed];
	if(iMaxY<m_aDrawY[iUsed])iMaxY=m_aDrawY[iUsed];
}

//*****************************************************************************
//*
//*		DrawMinMaxPoly
//*
//*****************************************************************************
//	Min-Max Werte von einem ganzen Polygon holen.
void CGameDalliView::DrawMinMaxPoly(int iPoly,int &iMinX,int &iMinY,int &iMaxX,int &iMaxY,int iSet)
{
int		iSize;
int		iUsed;


	if(iPoly<0 || iPoly>=m_iPolyCount)return;


	iUsed	= m_aDrawJump[iPoly];
	iSize	= m_aPolySize[iPoly];

	if(iUsed>=m_iDrawItems || iUsed<0)
		{
		return;
		}

	if(iSet)
		{
		iMinX	= m_aDrawX[iUsed];
		iMaxX	= m_aDrawX[iUsed];
		iMinY	= m_aDrawY[iUsed];
		iMaxY	= m_aDrawY[iUsed];
		}
	else{
		if(iMinX>m_aDrawX[iUsed])iMinX=m_aDrawX[iUsed];
		if(iMaxX<m_aDrawX[iUsed])iMaxX=m_aDrawX[iUsed];
		if(iMinY>m_aDrawY[iUsed])iMinY=m_aDrawY[iUsed];
		if(iMaxY<m_aDrawY[iUsed])iMaxY=m_aDrawY[iUsed];
		}

	for(;iSize>0;iSize--,iUsed++)
		{
		if(iMinX>m_aDrawX[iUsed])iMinX=m_aDrawX[iUsed];
		if(iMaxX<m_aDrawX[iUsed])iMaxX=m_aDrawX[iUsed];
		if(iMinY>m_aDrawY[iUsed])iMinY=m_aDrawY[iUsed];
		if(iMaxY<m_aDrawY[iUsed])iMaxY=m_aDrawY[iUsed];
		}

}

//*****************************************************************************
//*
//*		PointOnLine
//*
//*****************************************************************************
//	Prft ob ein Punkt auf einer Linie liegt
//	iPosX/Y		: Ist der Punkt
//	iUsed1/2	: Sind die Startpunkte der Linie (Inidzes)
//	Ergibt 1 wenn auf der Linie
int CGameDalliView::PointOnLine(int iPosX,int iPosY,int iUsed1,int iUsed2)
{
int		iLineX1;
int		iLineY1;
int		iLineX2;
int		iLineY2;
int		iStepX1;
int		iStepY1;
int		iStepX2;
int		iStepY2;
int		iDiffX2;
int		iDiffY2;
int		iDiffX;
int		iDiffY;
int		iDelta;
int		iShift;
int		iVal;


	iLineX1 = m_aDrawX[iUsed1];
	iLineY1 = m_aDrawY[iUsed1];
	iLineX2 = m_aDrawX[iUsed2];
	iLineY2 = m_aDrawY[iUsed2];
	iDiffX	= iLineX1-iLineX2;
	iDiffY	= iLineY1-iLineY2;
	iDiffX2	= iDiffX *iDiffX;
	iDiffY2	= iDiffY *iDiffY;
	iStepX2	= iPosX  -iLineX2;
	iStepY2	= iPosY  -iLineY2;


	if(iDiffX || iDiffY)									// Linienepunkte sind nicht gleich
		{
		iVal	= iDiffX*iStepY2 - iDiffY*iStepX2;

		if(iVal<0)iVal=-iVal;

		for(iShift=0;iVal&0xFFFF8000;iShift++)
			{
			iVal >>= 1;
			}

		iVal	= (iVal*iVal)/(iDiffX2+iDiffY2);
		iVal  <<= iShift;

		if(iVal>3*3)return 0;

		iDelta	= iDiffX2+iDiffY2;
		iVal	= iStepX2*iStepX2;
		iVal   += iStepY2*iStepY2;

		if(iVal>iDelta)return 0;
		}
	else{
		iDelta	= iDiffX2+iDiffY2;
		}

	iStepX1	= iPosX  -iLineX1;
	iStepY1	= iPosY  -iLineY1;
	iVal	= iStepX1*iStepX1;
	iVal   += iStepY1*iStepY1;

	if(iVal>iDelta)return 0;


return 1;
}

//*****************************************************************************
//*
//*		PointOnPoly
//*
//*****************************************************************************
//	Prft ob ein Punkt auf einer Polygonlinie liegt
//	iPosX/Y		: Ist der Punkt
//	Ergibt die Polygonnummer bzw. -1
int CGameDalliView::PointOnPoly(int iPosX,int iPosY)
{
int		iPoly;
int		iPos;
int		iOff;


	for(iPos=m_iDrawItems-1,iPoly=-1,iOff=0;iPos>=0;iPos--)
		{
		if(m_aDrawPoly[iPos]!=iPoly)
			{
			iPoly = m_aDrawPoly[iPos];
			iOff  = iPos;
			continue;
			}

		if(PointOnLine(iPosX,iPosY,iPos,iPos+1))
			{
			return iPoly|(iPos<<16);
			}

		if(m_aDrawStep[iPos]!=0)
			{
			continue;
			}

		if(PointOnLine(iPosX,iPosY,iPos,iOff))
			{
			return iPoly|(iPos<<16);
			}
		}


return -1;
}

//*****************************************************************************
//*
//*		PolygonHitTest
//*
//*****************************************************************************
//	Prft ob ein Punkt in einem Polygon liegt
//	iPosX/Y		: Koordinaten des Punktes
//	iSize		: Gre des Polygons in Punkten
//	pCoord		: Koordinaten des Polygons
int CGameDalliView::PolygonHitTest(int iPosX,int iPosY,int iSize,int *pCoord)
{
int		iDiffX2;
int		iDiffY2;
int		iDiffX;
int		iDiffY;
int		iStepX;
int		iStepY;
int		iShift;
int		iCross;
int		iNext2;
int		iPrev2;
int		iValP;
int		iValN;
int		iNext;
int		iPrev;
int		iStep;
int		iVal;



	if(iSize<=2)
		{
		if(iSize==1)											// Einzelner Punkt
			{
			if(iPosX==pCoord[0] && iPosY==pCoord[1])
				{
				return 1;
				}
			}
		else if(iSize==2)										// Linie zwischen zwei Punkten
			{
			iStepX	= iPosX    -pCoord[2];
			iStepY	= iPosY    -pCoord[3];
			iDiffX	= pCoord[0]-pCoord[2];
			iDiffY	= pCoord[1]-pCoord[3];
			iDiffX2	= iDiffX*iDiffX;
			iDiffY2	= iDiffY*iDiffY;

			iVal	= iDiffX*iStepY - iDiffY*iStepX;

			if(iVal<0)iVal=-iVal;

			for(iShift=0;iVal&0xFFFF8000;iShift++)				// Multiplikation ber 32 Bit
				{
				iVal >>= 1;
				}

			iVal	= (iVal*iVal)/(iDiffX2+iDiffY2);
			iVal  <<= iShift;

			return !iVal;
			}

		return 0;
		}


	iCross = 0;

	for(iPrev=0;iPrev<iSize;iPrev++)							// Alle Linien testen
		{
		   iNext = iPrev+1;
		if(iNext>=iSize)iNext=0;

		iDiffX	= pCoord[iNext*2  ]-pCoord[iPrev*2  ];
		iDiffY	= pCoord[iNext*2+1]-pCoord[iPrev*2+1];

		if(iDiffX)												// Ist X im Linienbereich
			{
			if(iDiffX<0)
				{
				if(iPosX<pCoord[iNext*2])continue;
				if(iPosX>pCoord[iPrev*2])continue;
				}
			else{
				if(iPosX>pCoord[iNext*2])continue;
				if(iPosX<pCoord[iPrev*2])continue;
				}

			iStep	= iPosX-pCoord[iPrev*2];
			iVal	= iDiffY*iStep/iDiffX+pCoord[iPrev*2+1];

			if(iVal<=iPosY)iCross++;

			continue;
			}


		if(iPosX!=pCoord[iPrev*2])								// Auf der sekrechten Linie
			{
			continue;
			}

		if(iDiffY<0)											// Sekrechte Linie
			{
			if(iPosY< pCoord[iNext*2+1])continue;
			if(iPosY<=pCoord[iPrev*2+1])return 1;
			}
		else{
			if(iPosY< pCoord[iPrev*2+1])continue;
			if(iPosY<=pCoord[iNext*2+1])return 1;
			}

		iStep	= 2;
		iValP	= iPosX;
		iValN	= iPosX;
		iPrev2	= iPrev-1;	if(iPrev2<0)iPrev2=iSize-1;
		iNext2	= iNext+1;	if(iNext2>=iSize)iNext2=0;

		while(iValP==pCoord[iPrev2*2])							// Suche nicht seknrechte Linien
			{
			iStep  += 1;
			iPrev2	= iPrev-1;
			if(iPrev2<0)iPrev2=iSize-1;
			if(iStep>=iSize)break;
			}

		while(iValN==pCoord[iNext2*2])
			{
			iStep  += 1;
			iNext2	= iNext-1;
			if(iNext2<0)iNext2=iSize-1;
			if(iStep>=iSize)break;
			}

		iValP -= pCoord[iPrev2*2];
		iValN -= pCoord[iNext2*2];

		if((iValP^iValN)<0)iCross++;							// Ist es keine Spitze
		}


return iCross&1;
}

//*****************************************************************************
//*
//*		DrawItemsInit
//*
//*****************************************************************************
void CGameDalliView::DrawItemsInit()
{
int		iPosY;
int		iPosX;
int		iPos;
int		iAll;
int		iOff;



	m_iDrawItems = 0;

	for(iPos=m_iPolyCount-1;iPos>=0;iPos--)					// Alle Plygone durchlaufen
		{
		iAll	= m_aPolySize[iPos];
		m_aDrawJump[iPos] = m_iDrawItems;

		if(iAll<2)continue;

		for(iOff=0;iOff<iAll;iOff++)						// Skaliertes Polygon holen
			{
			PolyToDraw(iPosX,iPosY,m_aPolygons[MAX_PT*2*iPos+iOff*2+0],m_aPolygons[MAX_PT*2*iPos+iOff*2+1]);

			m_aDrawX   [m_iDrawItems] = iPosX;				// Punkte abspeichern
			m_aDrawY   [m_iDrawItems] = iPosY;
			m_aDrawPoly[m_iDrawItems] = iPos;
			m_aDrawStep[m_iDrawItems] = iOff;
			m_iDrawItems++;
			}
		}

}

//*****************************************************************************
//*
//*		DrawCallback
//*
//*****************************************************************************
void _cdecl CGameDalliView::DrawCallback(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{
CGameDalliView *pThis=(CGameDalliView*)pParam;
COLORREF		uColor;
int				iWidth;
int				iHeigh;
int				iSizeX;
int				iSizeY;
int				iFromX;
int				iFromY;
int				iAddX;
int				iAddY;
int				iPosX;
int				iPosY;
int				iPos;
int				iIdx;
int				iNum;
int				iOff;
int				iAll;
int				iId;


	if(pThis->m_iDrawState==1 || pThis->m_iDrawState==2)		// Zeichen oder Sortieren
		{
		iWidth	= pThis->m_iWndSizeX-(pThis->m_iStarX+FRAME_SIZE)*2;
		iHeigh	= pThis->m_iWndSizeY-TEXT_LINE;
		iSizeX	= pThis->m_sPicImage.Width ();
		iSizeY	= pThis->m_sPicImage.Height();

		if(iSizeX<=0)iSizeX=1;
		if(iSizeY<=0)iSizeY=1;

		if(iWidth*iSizeY<iHeigh*iSizeX)							// Skalierung berechnen
			{
			iHeigh = (iSizeY*iWidth)/iSizeX;
			}
		else{
			iWidth = (iSizeX*iHeigh)/iSizeY;
			}

		if(iWidth*iSizeX>iHeigh*iSizeY)							// Mit grerem Paar rechnen
			{
			m_iDrawDiv = iSizeX;
			m_iDrawMul = iWidth;
			}
		else{
			m_iDrawDiv = iSizeY;
			m_iDrawMul = iHeigh;
			}

		if(m_iDrawMul<=0)m_iDrawMul=1;
		if(m_iDrawMul<=0)m_iDrawMul=1;
		if(m_iDrawDiv<=0)m_iDrawDiv=1;
		if(m_iDrawDiv<=0)m_iDrawDiv=1;

		m_iDrawAddX = (pThis->m_iWndSizeX-iWidth)/2;
		m_iDrawAddY = (pThis->m_iWndSizeY-iHeigh+TEXT_LINE)/2;

		if(pThis->m_iDrawState==2)								// Nur Sortieren
			{
			return;
			}

		pDc->SelectObject(GetStockObject(DC_PEN));
		pDc->SelectObject(GetStockObject(DC_BRUSH));

		m_iDrawItems = 0;

		for(iPos=m_iPolyCount-1;iPos>=0;iPos--)					// Alle Plygongitter zeichnen
			{
			iAll	= m_aPolySize[iPos];
			m_aDrawJump[iPos] = m_iDrawItems;

			if(iAll<2)continue;

			iId	    = m_aPolyId[iPos];
			uColor	= RGB((iId&0x01)*128+(iId&0x08)*8+64,(iId&0x02)*64+(iId&0x10)*64+64,(iId&0x04)*32+64);

			SetDCPenColor  (pDc->m_hDC,uColor);
			SetDCBrushColor(pDc->m_hDC,uColor);


			for(iOff=0;iOff<iAll;iOff++)						// Skaliertes Polygon holen
				{
				PolyToDraw(iPosX,iPosY,m_aPolygons[MAX_PT*2*iPos+iOff*2+0],m_aPolygons[MAX_PT*2*iPos+iOff*2+1]);

				pDc->Rectangle(iPosX-3,iPosY-3,iPosX+4,iPosY+4);

				m_aDrawX   [m_iDrawItems] = iPosX;				// Punkte abspeichern
				m_aDrawY   [m_iDrawItems] = iPosY;
				m_aDrawPoly[m_iDrawItems] = iPos;
				m_aDrawStep[m_iDrawItems] = iOff;
				m_iDrawItems++;

				if(iPos==m_iDrawBase)
					{
					continue;
					}

				if(iOff)
					{
					pDc->LineTo(iPosX,iPosY);
					continue;
					}

				pDc->MoveTo(iPosX,iPosY);						// Erster Punkt
				iFromX = iPosX;
				iFromY = iPosY;
				}

			if(iPos==m_iDrawBase)continue;

			pDc->LineTo(iFromX,iFromY);

			for(iNum=0;iNum<4;iNum++)							// Linie verbreitern
				{
				if(iNum&2)
					{
					iAddX	= 0;
					iAddY	= (iNum&1)? -1:1;
					}
				else{
					iAddY	= 0;
					iAddX	= (iNum&1)? -1:1;
					}


				pDc->MoveTo(m_aDrawX[m_iDrawItems-1]+iAddX,m_aDrawY[m_iDrawItems-1]+iAddY);

				for(iOff=-iAll;iOff<0;iOff++)					// Skaliertes Polygon holen
					{
					pDc->LineTo(m_aDrawX[m_iDrawItems+iOff]+iAddX,m_aDrawY[m_iDrawItems+iOff]+iAddY);
					}
				}
			}


		if(m_iDrawBase>=0 && m_iDrawBase<m_iPolyCount)			// Oberstes Polygon zeichnen
			{
			iPos	= m_iDrawBase;
			iAll	= m_aPolySize[iPos];
			iIdx	= m_aDrawJump[iPos];
			iId	    = m_aPolyId  [iPos];
			uColor	= RGB((iId&0x01)*128+(iId&0x08)*8+64,(iId&0x02)*64+(iId&0x10)*64+64,(iId&0x04)*32+64);

			SetDCPenColor  (pDc->m_hDC,uColor);
			SetDCBrushColor(pDc->m_hDC,uColor);

			for(iNum=0;iNum<=4;iNum++)							// Linie verbreitern
				{
				if(iNum==4)
					{
					iAddX	= 0;
					iAddY	= 0;
					}
				else if(iNum&2)
					{
					iAddX	= 0;
					iAddY	= (iNum&1)? -1:1;
					}
				else{
					iAddY	= 0;
					iAddX	= (iNum&1)? -1:1;
					}

				pDc->MoveTo(m_aDrawX[iIdx+iAll-1]+iAddX,m_aDrawY[iIdx+iAll-1]+iAddY);

				for(iOff=0;iOff<iAll;iOff++)				// Skaliertes Polygon holen
					{
					iPosX = m_aDrawX[iIdx+iOff];
					iPosY = m_aDrawY[iIdx+iOff];
					pDc->LineTo(iPosX+iAddX,iPosY+iAddY);
					pDc->Rectangle(iPosX-3,iPosY-3,iPosX+4,iPosY+4);
					}
				}
			}
		}





}

//*****************************************************************************
//*
//*		MouseCallback
//*
//*****************************************************************************
void _cdecl CGameDalliView::MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint)
{
CGameDalliView     *pThis=(CGameDalliView*)pParam;
int					aData[MAX_POLY*MAX_PT*2];
int					iFixed;
int					iMinX;
int					iMinY;
int					iMaxX;
int					iMaxY;
int					iSize;
int					iStep;
int					iPoly;
int					iPosX;
int					iPosY;
int					iPos;
int					iOff;
int					iId;


	if(m_iDrawState==0 || m_iDrawState>2)
		{
		if(m_iDrawMode)
			{
			ReleaseCapture();
			m_iDrawMode = 0;
			}

		return;
		}
	else if(m_iDrawState==2)										// Sortieren
		{
		if(m_iDrawMode)
			{
			ReleaseCapture();
			m_iDrawMode = 0;
			}

		if(uType==WM_LBUTTONDOWN)
			{
			DrawToPoly(iPosX,iPosY,sPoint.x,sPoint.y);

			for(iPos=0;iPos<m_iPolyCount;iPos++)
				{
				if(!PolygonHitTest(iPosX,iPosY,m_aPolySize[iPos],m_aPolygons+iPos*MAX_PT*2))
					{
					continue;
					}

				CString sName;

				iId	  = m_aPolyId  [iPos];
				iSize = m_aPolySize[iPos];
				sName = m_aPolyName[iPos];
				memcpy (&sName,m_aPolyName+iPos         ,sizeof(m_aPolyName[0]));
				memcpy ( aData,m_aPolygons+iPos*MAX_PT*2,sizeof(m_aPolygons[0])*MAX_PT*2);

				memmove(m_aPolygons+MAX_PT*2,m_aPolygons,sizeof(m_aPolygons[0])*iPos*MAX_PT*2);
				memmove(m_aPolySize+1       ,m_aPolySize,sizeof(m_aPolySize[0])*iPos);
				memmove(m_aPolyName+1       ,m_aPolyName,sizeof(m_aPolyName[0])*iPos);
				memmove(m_aPolyId  +1       ,m_aPolyId  ,sizeof(m_aPolyId  [0])*iPos);

				m_aPolyId  [0] = iId;
				m_aPolySize[0] = iSize;
				memcpy(m_aPolyName,&sName,sizeof(m_aPolyName[0]));
				memcpy(m_aPolygons, aData,sizeof(m_aPolygons[0])*MAX_PT*2);

				pThis->m_bChanged =  1;
				pThis->m_iPolyNow = -2;
				pThis->OnTimer(IDC_UPDATE);
				pThis->RedrawWindow();
				break;
				}
			}

		return;
		}

	switch(uType)
		{
	case WM_MOUSEMOVE:

		if(m_iDrawMode==1)										// Einen Punkt verschieben
			{
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,1);
			m_aDrawX[m_iDrawUsed] = sPoint.x;
			m_aDrawY[m_iDrawUsed] = sPoint.y;
			DrawToPoly(m_iDrawUsed,sPoint.x,sPoint.y);
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,0);
			pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
			SetCursor(IDC_HAND);
			break;
			}

		if(m_iDrawMode==2)										// Polygonende zeichnen
			{
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,1);
			m_aDrawX[m_iDrawUsed] = sPoint.x;
			m_aDrawY[m_iDrawUsed] = sPoint.y;
			DrawToPoly(m_iDrawUsed,sPoint.x,sPoint.y);
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,0);
			pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
			SetCursor(IDC_CROSS);
			break;
			}

		iMinX	= sPoint.x-3;
		iMinY	= sPoint.y-3;
		iMaxX	= sPoint.x+3;
		iMaxY	= sPoint.y+3;

		if(m_iDrawBase>=0)										// Ist ein Polygon gewhlt
		for(iPos=m_aDrawStep[m_iDrawBase];;iPos--)
			{
			if(m_iDrawBase!=m_aDrawPoly[iPos])break;
			if(iMaxX<m_aDrawX[iPos])continue;
			if(iMinX>m_aDrawX[iPos])continue;
			if(iMaxY<m_aDrawY[iPos])continue;
			if(iMinY>m_aDrawY[iPos])continue;

			m_iDrawUsed = iPos;
			SetCursor((iPos>=0)? IDC_CROSS:IDC_ARROW);

			return;
			}

		for(iPos=m_iDrawItems-1;iPos>=0;iPos--)					// Ist Maus ber einen Punkt
			{
			if(iMaxX<m_aDrawX[iPos])continue;
			if(iMinX>m_aDrawX[iPos])continue;
			if(iMaxY<m_aDrawY[iPos])continue;
			if(iMinY>m_aDrawY[iPos])continue;
			break;
			}

		m_iDrawUsed = iPos;
		SetCursor((iPos>=0 && !(GetAsyncKeyState(VK_CONTROL)&0x8000))? IDC_CROSS:IDC_ARROW);
		break;

	case WM_RBUTTONDOWN:										// Abbrechen mit der rechten Taste

		if(m_iDrawMode)
			{
			pThis->OnKeyDown(VK_ESCAPE,1,0);
			}

		break;

	case WM_LBUTTONDBLCLK:
	case WM_LBUTTONDOWN:

		if(m_iDrawType==0)										// Punkte Verschiben
			{
			if(m_iDrawUsed>=0)									// Einen Punkt greifen
				{
				pThis->m_cBitmapWnd.SetCapture();
				PolyToTake(m_iDrawUsed,m_iDrawOldX,m_iDrawOldY);
				m_iDrawPosX = m_aDrawX   [m_iDrawUsed];
				m_iDrawPosY = m_aDrawY   [m_iDrawUsed];

				if(m_iDrawBase!=m_aDrawPoly[m_iDrawUsed])
					{
					DrawMinMaxPoly(m_iDrawBase             ,iMinX,iMinY,iMaxX,iMaxY,1);
					DrawMinMaxPoly(m_aDrawPoly[m_iDrawUsed],iMinX,iMinY,iMaxX,iMaxY,m_iDrawBase<0);
					pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
					m_iDrawBase = m_aDrawPoly[m_iDrawUsed];
					}

				m_iDrawMode = 1;
				SetCursor(IDC_HAND);
				}
			else{
				   iPoly = PointOnPoly(sPoint.x,sPoint.y);
				if(iPoly>=0 && iPoly!=m_iDrawBase)				// Auf Linie geklickt
					{
					DrawMinMaxPoly(m_iDrawBase,iMinX,iMinY,iMaxX,iMaxY,1);
					DrawMinMaxPoly(iPoly      ,iMinX,iMinY,iMaxX,iMaxY,m_iDrawBase<0);
					pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
					m_iDrawBase = iPoly;
					}
				}

			break;
			}

		if(m_iDrawType==1)										// Etwas Zeichnen
			{
			iFixed = -1;

			if(uType==WM_LBUTTONDBLCLK)
				{
				pThis->OnKeyDown(VK_ESCAPE,1,0);
				return;
				}

			if(m_iDrawMode==2)									// Wird bereits gezeichnet
				{
				iPoly	= m_iDrawBase;
				if(iPoly<0 || iPoly>=m_iPolyCount)break;

				iMinX	= sPoint.x-6;
				iMinY	= sPoint.y-6;
				iMaxX	= sPoint.x+6;
				iMaxY	= sPoint.y+6;
																// Immer noch am gleichen Punkt
				if(iMaxX>=m_iDrawPosX && iMinX<=m_iDrawPosX && iMaxY>=m_iDrawPosY && iMinY<=m_iDrawPosY)
					{
					pThis->OnKeyDown(VK_ESCAPE,1,0);
					return;
					}

				for(iPos=m_iDrawItems-1;iPos>=0;iPos--)			// Ist Cursor ber einen Punkt
					{
					if(iPos ==  m_iDrawUsed)continue;
					if(iMaxX<m_aDrawX[iPos])continue;
					if(iMinX>m_aDrawX[iPos])continue;
					if(iMaxY<m_aDrawY[iPos])continue;
					if(iMinY>m_aDrawY[iPos])continue;

					if(m_aDrawPoly[iPos]==iPoly)
						{
						pThis->OnKeyDown(VK_ESCAPE,1,0);
						return;
						}

					iFixed = iPos;
					}
				}
			else{
				if(GetAsyncKeyState(VK_CONTROL)&0x8000)
					{
					goto Direct;
					}

				   iPoly = PointOnPoly(sPoint.x,sPoint.y);
				if(iPoly>=0)
					{
					m_iDrawUsed = iPoly>>16;
					}
				}

			if(m_iDrawUsed>=0 || iFixed>=0)						// Bei einem Punkt weiter zeichnen
				{
				iPoly	= m_aDrawPoly[m_iDrawUsed];
				iStep	= m_aDrawStep[m_iDrawUsed];
				iSize	= m_aPolySize[iPoly ];

				if(iFixed>=0)
					{
					PolyToTake(iFixed,m_iDrawOldX,m_iDrawOldY);
					m_iDrawPosX = m_aDrawX[iFixed];
					m_iDrawPosY = m_aDrawY[iFixed];
					}
				else{
					PolyToTake(m_iDrawUsed,m_iDrawOldX,m_iDrawOldY);
					m_iDrawPosX = m_aDrawX[m_iDrawUsed];
					m_iDrawPosY = m_aDrawY[m_iDrawUsed];
					}


				if(iSize>=MAX_PT)
					{
					MessageBeep(MB_ICONEXCLAMATION);
					break;
					}

				if(iSize!=iStep+1)								// Punkte rotieren
					{
					for(iPos=0;iPos<iSize;iPos++)
						{
						iOff  = ((iPos+iSize+1+iStep)%iSize)*2;
						iOff += iPoly*MAX_PT*2;
						aData[iPos*2+0] = m_aPolygons[iOff+0];
						aData[iPos*2+1] = m_aPolygons[iOff+1];
						}

					memcpy(m_aPolygons+iPoly*MAX_PT*2,aData,iSize*2*sizeof(int));
					pThis->RedrawWindow();
					}

				iOff = iPoly*MAX_PT*2+iSize*2;

				if(iFixed>=0 && iSize>0)						// Jetztigen Punk einrasten
					{
					m_aPolygons[iOff-2] = m_iDrawOldX;
					m_aPolygons[iOff-1] = m_iDrawOldY;
					}
																// Einen Punkt in die Liste einfgen
				DrawToPoly(m_aPolygons[iOff],m_aPolygons[iOff+1],sPoint.x,sPoint.y);
				m_aPolySize[iPoly] = iSize+1;
				m_iDrawUsed  = m_aDrawJump[iPoly];
				m_iDrawUsed += iSize;
				DrawItemsInit();


				DrawMinMaxPoly(m_iDrawBase,iMinX,iMinY,iMaxX,iMaxY,1);
				DrawMinMaxPoly(iPoly      ,iMinX,iMinY,iMaxX,iMaxY,m_iDrawBase<0);
				pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
				pThis->m_cBitmapWnd.SetCapture();
				pThis->m_cBitmapWnd.RedrawWindow();
				m_iDrawBase =iPoly;

				if(m_iDrawMode==2)
					{
					pThis->m_bChanged = 1;
					}
				else{
					m_iDrawMode = 2;
					}

				break;
				}

Direct:		if(m_iPolyCount>=MAX_POLY)
				{
				MessageBeep(MB_ICONEXCLAMATION);
				break;
				}

			iPoly = m_iPolyCount;
			iOff  = iPoly*MAX_PT*2;						// Zwei Punkte in die Liste einfgen

			if(m_iDrawUsed>=0)
				{
				PolyToTake(m_iDrawUsed,iPosX,iPosY);
				m_aPolygons[iOff+0] = iPosX;
				m_aPolygons[iOff+1] = iPosY;
				m_aPolygons[iOff+2] = iPosX;
				m_aPolygons[iOff+3] = iPosY;
				}
			else{
				DrawToPoly(m_aPolygons[iOff+0],m_aPolygons[iOff+1],sPoint.x,sPoint.y);
				DrawToPoly(m_aPolygons[iOff+2],m_aPolygons[iOff+3],sPoint.x,sPoint.y);
				}

			m_aPolySize[iPoly] = 2;
			m_iPolyCount++;
			DrawItemsInit();
			m_iDrawUsed = m_aDrawJump[iPoly]+1;
			m_iDrawPosX = sPoint.x;
			m_iDrawPosY = sPoint.y;

			DrawMinMaxPoly(m_iDrawBase,iMinX,iMinY,iMaxX,iMaxY,1);
			DrawMinMaxPoly(iPoly      ,iMinX,iMinY,iMaxX,iMaxY,m_iDrawBase<0);
			pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
			pThis->m_cBitmapWnd.SetCapture();
			pThis->m_cBitmapWnd.RedrawWindow();
			m_iDrawBase = iPoly;
			m_iDrawMode = 2;
			break;
			}

		if(m_iDrawType==2)										// Etwas Lschen
			{
			if(m_iDrawUsed>=0)									// Einen Punkt lschen
				{
				iPoly	= m_aDrawPoly[m_iDrawUsed];
				iStep	= m_aDrawStep[m_iDrawUsed];

				if(iPoly>=m_iPolyCount      )break;
				if(iStep>=m_aPolySize[iPoly])break;

				m_aPolySize[iPoly]--;
				iSize	= m_aPolySize[iPoly]-iStep;
				memmove(m_aPolygons+MAX_PT*2*iPoly+iStep*2,m_aPolygons+MAX_PT*2*iPoly+iStep*2+2,sizeof(m_aPolygons[9])*iSize*2);

				if(m_iDrawBase!=iPoly)
					{
					DrawMinMaxPoly(m_iDrawBase,iMinX,iMinY,iMaxX,iMaxY,1);
					DrawMinMaxPoly(iPoly      ,iMinX,iMinY,iMaxX,iMaxY,m_iDrawBase<0);
					pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
					m_iDrawBase = iPoly;
					}

				if(m_aPolySize[iPoly]<=2)						// Polygon lschen unter 2 Punkten
					{
					m_iPolyCount--;
					iSize = m_iPolyCount-iPoly;
					iId   = m_aPolyId[iPoly];
					memmove(m_aPolyId  +iPoly,m_aPolyId  +iPoly+1,sizeof(m_aPolyId  [0])*iSize);
					memmove(m_aPolySize+iPoly,m_aPolySize+iPoly+1,sizeof(m_aPolySize[0])*iSize);
					memmove(m_aPolygons+MAX_PT*2*iPoly,m_aPolygons+MAX_PT*2*iPoly+MAX_PT*2,sizeof(m_aPolygons[0])*iSize*MAX_PT*2);
					m_aPolyId[m_iPolyCount]=iId;
					m_iDrawBase = -1;
					}

				pThis->m_bChanged   =  1;
				m_iDrawUsed			= -1;
				pThis->RedrawWindow();

				break;
				}

			if(m_iDrawUsed<0)										// Cursor auf einer Linie
				{
				   iPoly = PointOnPoly(sPoint.x,sPoint.y);
				if(iPoly<0)return;
				   iPoly &= 0xFFFF;
				if(iPoly>=m_iPolyCount)return;

				m_iPolyCount--;										// Ganzes Polygon lschen
				iSize = m_iPolyCount-iPoly;
				iId   = m_aPolyId[iPoly];
				memmove(m_aPolyId  +iPoly,m_aPolyId  +iPoly+1,sizeof(m_aPolyId  [0])*iSize);
				memmove(m_aPolySize+iPoly,m_aPolySize+iPoly+1,sizeof(m_aPolySize[0])*iSize);
				memmove(m_aPolygons+MAX_PT*2*iPoly,m_aPolygons+MAX_PT*2*iPoly+MAX_PT*2,sizeof(m_aPolygons[0])*iSize*MAX_PT*2);
				m_aPolyId[m_iPolyCount]=iId;
				m_iDrawBase			= -1;
				pThis->m_bChanged   =  1;
				m_iDrawUsed			= -1;
				pThis->RedrawWindow();

				break;
				}
			}

		break;

	case WM_LBUTTONUP:

		if(m_iDrawMode==1)										// Einen Punkt loslassen
			{
			ReleaseCapture();
			m_iDrawMode = 0;

			iMinX	= sPoint.x-6;
			iMinY	= sPoint.y-6;
			iMaxX	= sPoint.x+6;
			iMaxY	= sPoint.y+6;
																// Immer noch am gleichen Punkt
			if(iMaxX>=m_iDrawPosX && iMinX<=m_iDrawPosX && iMaxY>=m_iDrawPosY && iMinY<=m_iDrawPosY)								// Am selben Punkt
				{
				DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,1);
				m_aDrawX[m_iDrawUsed] = m_iDrawPosX;
				m_aDrawY[m_iDrawUsed] = m_iDrawPosY;
				TakeToPoly(m_iDrawUsed,m_iDrawOldX,m_iDrawOldY);
				DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,0);
				pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
				break;
				}

			for(iPos=m_iDrawItems-1;iPos>=0;iPos--)				// Ist Cursor ber einen Punkt
				{
				if(iPos==m_iDrawUsed)continue;
				if(iMaxX<m_aDrawX[iPos])continue;
				if(iMinX>m_aDrawX[iPos])continue;
				if(iMaxY<m_aDrawY[iPos])continue;
				if(iMinY>m_aDrawY[iPos])continue;

				DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,1);
				m_aDrawX[m_iDrawUsed] = m_aDrawX[iPos];
				m_aDrawY[m_iDrawUsed] = m_aDrawY[iPos];
				PolyToPoly(m_iDrawUsed,iPos);					// Neuen Punkt speichern
				DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,0);
				pThis->m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
				break;
				}

			pThis->m_bChanged = 1;
			break;
			}
		}

}

//*****************************************************************************
//*
//*		OnKeyDown
//*
//*****************************************************************************
void CGameDalliView::OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags)
{
int			iPoly;
int			iMinX;
int			iMinY;
int			iMaxX;
int			iMaxY;

	switch(nChar)
		{
	case VK_ESCAPE:

		if(m_iDrawMode==1)										// Einen Punkt ohne nderung loslassen
			{
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,1);
			m_aDrawX[m_iDrawUsed] = m_iDrawPosX;
			m_aDrawY[m_iDrawUsed] = m_iDrawPosY;
			TakeToPoly(m_iDrawUsed,m_iDrawOldX,m_iDrawOldY);
			DrawMinMax(m_iDrawUsed,iMinX,iMinY,iMaxX,iMaxY,0);

			ReleaseCapture();
			m_iDrawMode=0;
			m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
			SetCursor(IDC_ARROW);
			break;
			}

		if(m_iDrawMode==2)										// Einen Punkt ohne nderung loslassen
			{
			ReleaseCapture();
			m_iDrawMode = 0;
			iPoly = m_iDrawBase;

			if(iPoly>=0 && iPoly<m_iPolyCount)
				{
				DrawMinMaxPoly(iPoly,iMinX,iMinY,iMaxX,iMaxY,1);
				m_cBitmapWnd.InvalidateRect(iMinX-4,iMinY-4,iMaxX-iMinX+8,iMaxY-iMinY+8);
				m_aPolySize[iPoly]--;

				if(m_aPolySize[iPoly]<=2 && m_iPolyCount>0)
					{
					m_iPolyCount--;
					}
				}

			return;
			}

		break;

	case VK_CONTROL:

		if(m_iDrawType==1 && m_iDrawMode!=2)
			{
			SetCursor(IDC_ARROW);
			}

		break;
		}

	CView::OnKeyDown(nChar,nRepCnt,nFlags);
}


//*****************************************************************************
//*
//*		CheckSave
//*
//*****************************************************************************
void CGameDalliView::CheckSave(int iQuery)
{
char		cBuffer[4096];
char		cPath[MAX_PATH];
CString		sText;
FILE	   *pFile;
unsigned	uColor;
int			iSizeX;
int			iSizeY;
int			iLen;
int			iPos;
int			iOff;



	if(!m_bChanged)return;

	m_bChanged = FALSE;

	if(m_uGameNumber<=0)return;

	sText.Format("Das Spiel Game%03i wurde verndert.\nSoll es gespeichert werden ?",m_uGameNumber);

	if(iQuery && MessageBox(sText,"Speichern",MB_YESNO|MB_ICONQUESTION)!=IDYES)
		{
		return;
		}

	CreatePath(m_sPicPath);
	sprintf(cPath,"%s\\Game%03i\\Pic.txt",(LPCTSTR)m_sPicPath,m_uGameNumber);
	iLen=sprintf(cPath,"%s\n%s\n",m_aPicText,m_aPicInfo);
	SaveMemory(cPath,cBuffer,iLen);

	sprintf(cPath,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,m_uGameNumber);

		pFile = fopen(cPath,"wb");
	if(!pFile)return;

	iSizeX = m_sPicImage.Width ();
	iSizeY = m_sPicImage.Height();

	fprintf(pFile,"<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n");
	fprintf(pFile,"<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.0//EN\" \"http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd\">\n");
	fprintf(pFile,"<!-- Creator: CorelDRAW -->\n");
	fprintf(pFile,"<svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:odm=\"http://product.corel.com/CGS/11/cddns/\" xmlns:corel-charset=\"http://product.corel.com/CGS/11/cddns/\" xml:space=\"preserve\" width=\"60.4724in\" height=\"40.315in\" style=\"shape-rendering:geometricPrecision; text-rendering:geometricPrecision; image-rendering:optimizeQuality; fill-rule:evenodd\" viewBox=\"-100 -100 %i %i\">\n",iSizeX+100,iSizeY+100);
	fprintf(pFile," <defs>\n");
	fprintf(pFile,"  <style type=\"text/css\">\n");
	fprintf(pFile,"   <![CDATA[\n");

	for(iPos=0;iPos<m_iPolyCount;iPos++)
		{
		uColor	= RGB((iPos&0x01)*128+(iPos&0x08)*8+64,(iPos&0x02)*64+(iPos&0x10)*64+64,(iPos&0x04)*32+64);
		fprintf(pFile,"    .str%i {stroke:#%06X;stroke-width:222.22}\n",iPos,uColor);
		}

	fprintf(pFile,"    .fil0 {fill:none}\n");
	fprintf(pFile,"   ]]>\n");
	fprintf(pFile,"  </style>\n");
	fprintf(pFile,"  <clipPath id=\"id0\">\n");
	fprintf(pFile,"   <rect transform=\"matrix(1 0 0 1 0 0)\" x=\"0\" y=\"0\" width=\"%i\" height=\"%i\"/>\n",iSizeX,iSizeY,iSizeX,iSizeY);
	fprintf(pFile,"  </clipPath>\n");
	fprintf(pFile," </defs>\n");
	fprintf(pFile," <g id=\"Ebene_x0020_1\">\n");
	fprintf(pFile,"  <image transform=\"matrix(1 0 0 1 0 0)\" x=\"0\" y=\"0\" width=\"%i\" height=\"%i\" xlink:href=\"Pic.png\"/>\n",iSizeX,iSizeY);

	for(iPos=0;iPos<m_iPolyCount;iPos++)
		{
		uColor	= RGB((iPos&0x01)*128+(iPos&0x08)*8+64,(iPos&0x02)*64+(iPos&0x10)*64+64,(iPos&0x04)*32+64);
		fprintf(pFile,"  <path class=\"fil0 str%i\" d=\"M",iPos);

		for(iOff=0;iOff<m_aPolySize[iPos];iOff++)
			{
			fprintf(pFile,"%i %i%s",m_aPolygons[MAX_PT*2*iPos+iOff*2],m_aPolygons[MAX_PT*2*iPos+iOff*2+1],(iOff+1!=m_aPolySize[iPos])? " ":"");
			}

		fprintf(pFile,"z\"/>\n");
		}

	fprintf(pFile," </g>\n");
	fprintf(pFile,"</svg>\n");

	fclose(pFile);

}

//*****************************************************************************
//*
//*		OnNewPic
//*
//*****************************************************************************
void CGameDalliView::OnNewPic()
{
static CNewPicDlg	sDlg;
char				cBuffer[4096];
char				cPath[MAX_PATH];
char				cTemp[MAX_PATH];
int					iPos;
int					iLen;


	if(m_iDrawState!=1)return;

	   sDlg.m_iNumber	= m_uGameNumber;
	if(sDlg.m_iNumber<0)sDlg.m_iNumber=1;

	if(sDlg.DoModal()!=IDOK)return;

	SetCursor(IDC_WAIT);


	switch(sDlg.m_iMode)
		{
	case 0:													// Nchster freier Platz

			if(sDlg.m_iNumber<1)sDlg.m_iNumber=1;

			for(;sDlg.m_iNumber<1000;sDlg.m_iNumber++)
				{
				sprintf(cPath,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
				if(ExistFile(cPath)!=1)break;
				}

			break;

	case 1:													// Einfgen

			if(sDlg.m_iNumber<1)sDlg.m_iNumber=1;

			sprintf(cPath,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
			if(ExistFile(cPath)!=1)break;

			for(iPos=sDlg.m_iNumber;iPos<1000;iPos++)
				{
				sprintf(cPath,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,iPos);
				if(ExistFile(cPath)!=1)break;
				}

			if(iPos>=1000)									// Kein freier Platz
				{
				MessageBox("Es wurde kein freier Platz gefunden !","Fehler",MB_OK|MB_ICONERROR);
				return;
				}

			for(;iPos>sDlg.m_iNumber;iPos--)
				{
				sprintf(cPath,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,iPos  );
				sprintf(cTemp,"%s\\Game%03i\\Pic.svg",(LPCTSTR)m_sPicPath,iPos-1);

				if(!MoveFile(cTemp,cPath))
					{
					MessageBox("Es gab einen Fehler beim Einfgen !","Fehler",MB_OK|MB_ICONERROR);
					return;
					}
				}

			break;
		}


	if(sDlg.m_iNumber>=1000 || sDlg.m_iNumber<1)			// Bildnummer prfen
		{
		MessageBox("Die Bildenummer ist falsch (1..999) !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}


	sprintf(cTemp,"%s\\Game%03i",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
	sprintf(cPath,"%s\\Game%03i\\Pic.png",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);

	CreatePath(cTemp);

	if(ImageLoader(sDlg.m_sPath,&m_sPicImage))				// Neues Bild laden
		{
		MessageBox("Das Bild konnte nicht geladen werden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(sDlg.m_sPath!=cPath)
		{
		if(ImageSaver(cPath,&m_sPicImage))
			{
			MessageBox("Es gab einen Fehler beim Speichern des Bildes !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}
		}

	sprintf(cPath,"%s\\Game%03i\\Pic.txt",(LPCTSTR)m_sPicPath,sDlg.m_iNumber);
	iLen = sprintf(cBuffer,"%s\n%s\n",(LPCTSTR)sDlg.m_sText,(LPCTSTR)sDlg.m_sInfo);
	SaveMemory(cPath,cBuffer,iLen);

	strlcpy(m_aPicText,sDlg.m_sText,sizeof(m_aPicInfo));
	strlcpy(m_aPicInfo,sDlg.m_sInfo,sizeof(m_aPicInfo));
	strlcpy(m_aPicOut ,sDlg.m_sText,sizeof(m_aPicInfo));

	m_bRunning		= 0;
	m_bChanged		= 1;
	m_iPolyCount	= 0;
	m_uGameNumber   = sDlg.m_iNumber;
	m_uStartTick	= GetTickCount();
	m_iTextLine		= 1;
	m_bRunning		= 1;
	m_iPolyNow		=-2;
	m_iPolyStep		=-1;

	OnTimer(IDC_UPDATE);
	RedrawWindow();

}

