//*****************************************************************************
//*
//*
//*		GameDalliView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_GAMEDALLIVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_
#define		AFX_GAMEDALLIVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_	

#if _MSC_VER > 1000
#pragma		once						
#endif

#define 	MAX_PT			32
#define 	MAX_POLY		32
		

//*****************************************************************************
//*
//*		Klasse CGameDalliView
//*
//*****************************************************************************
class CGameDalliView : public CView
{
protected:

	CGameDalliView();
	DECLARE_DYNCREATE(CGameDalliView)

public:

	CGameDalliDoc* GetDocument();

	void		 SetZoom(int iZoom);
	void		 UseImage(int iMode);
	void		 Stop (unsigned uPlace);
	void		 SetStartPath(LPCTSTR pPath);
	void		 Start();
	void		 Reset();


	//{{AFX_VIRTUAL(CGameDalliView)
public:
	virtual void OnDraw(CDC* pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	//}}AFX_VIRTUAL

public:
	virtual ~CGameDalliView();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	BYTE			m_uHgOk;
	BOOL			m_bChanged;
	BOOL			m_bRunning;
	BOOL			m_bColorMode;
	BYTE			m_aStars[64];
	BYTE			m_aStop	 [2];
	BYTE			m_aBgNum [2];
	BYTE			m_aPoints[2];
	CBitmapWnd		m_cBitmapWnd;
	static DWORD	m_aHgColors[];
	BitmapImage		m_sStarImg1;
	BitmapImage		m_sStarImg2;
	BitmapImage		m_sStarImg3;
	BitmapImage		m_sStarImg;
	BitmapImage		m_sPicImage;
	BitmapImage		m_sPicPoly;
	CRect			m_sWndRect;
	DWORD			m_uDeltaTick;
	static DWORD	m_uLastCling;
	DWORD			m_uLastTick;
	DWORD			m_uLastZoom;
	DWORD			m_uStartTick;
	DWORD			m_uGameNumber;
	DWORD			m_uSwitchTime;
	CString			m_sPicPath;
	CString			m_sPicOrig;
	char 			m_aPicText[256];
	char 			m_aPicInfo[256];
	char 			m_aPicOut [256];
	int				m_iNumberX;
	int				m_iNumberY;
	int				m_iWndSizeX;
	int				m_iWndSizeY;
	int				m_iTextLine;
	int				m_iStarSize;
	int				m_iStarRows;
	int				m_iStarMax;
	int				m_iStarX;
	int				m_iStarY;
	int				m_iZoom;
	int volatile	m_iStop;
	int volatile	m_iDone;
	int volatile	m_iPort;
	int volatile	m_iAudioRun;
	int volatile	m_iAudioStop;
	int				m_iPolyNow;
	int				m_iPolyInfo;
	int				m_iPolyStep;
	static int		m_iPolyCount;
	static BYTE		m_aPolyId  [MAX_POLY];
	static int  	m_aDrawJump[MAX_POLY];
	static int		m_aPolySize[MAX_POLY];
	static int 		m_aPolygons[MAX_POLY*MAX_PT*2];
	static CString	m_aPolyName[MAX_POLY];
	static int 		m_iDrawUsed;
	static int 		m_iDrawMode;
	static int 		m_iDrawType;
	static int 		m_iDrawBase;
	static int 		m_iDrawPoly;
	static int 		m_iDrawStep;
	static int 		m_iDrawOldX;
	static int 		m_iDrawOldY;
	static int 		m_iDrawPosX;
	static int 		m_iDrawPosY;
	static int 		m_iDrawItems;
	static int		m_iDrawState;
	static int 		m_iDrawMul;
	static int 		m_iDrawDiv;
	static int 		m_iDrawAddX;
	static int 		m_iDrawAddY;
	static CPoint 	m_sDrawStart;
	static int		m_iDrawFlag;
	static int		m_iDrawMove;
	static int 		m_aDrawX   [MAX_POLY*MAX_PT];
	static int 		m_aDrawY   [MAX_POLY*MAX_PT];
	static BYTE 	m_aDrawPoly[MAX_POLY*MAX_PT];
	static BYTE 	m_aDrawStep[MAX_POLY*MAX_PT];
	static UINT		m_uAudioPos;
	static short   *m_pCling1;
	static UINT		m_uCling1Len;
	static HRSRC	m_hCling1Src;
	static HGLOBAL	m_hCling1Hg;
	static short   *m_pCling2;
	static UINT		m_uCling2Len;
	static HRSRC	m_hCling2Src;
	static HGLOBAL	m_hCling2Hg;
	static short   *m_pDalli;
	static UINT		m_uDalliLen;
	static HRSRC	m_hDalliSrc;
	static HGLOBAL	m_hDalliHg;
	static short   *m_pTick;
	static UINT		m_uTickLen;
	static HRSRC	m_hTickSrc;
	static HGLOBAL	m_hTickHg;
	static short   *m_aPlay[4];
	static UINT		m_aPlayLen[4];
	static BYTE		m_aFontS[];
	static BYTE		m_aFontX[];
	static BYTE		m_aFont[];
	CSemaphore		m_sAudioSem;

protected:
	//{{AFX_MSG(CGameDalliView)
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnKeyDown(UINT nChar,UINT nRepCnt,UINT nFlags);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSaveUI(CCmdUI *pCmdUI);
	afx_msg void OnPolyInfoUI(CCmdUI *pCmdUI);
	afx_msg void OnColorModeUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageAUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageBUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageCUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageDUI(CCmdUI *pCmdUI);
	afx_msg void OnDrawMoveUI(CCmdUI *pCmdUI);
	afx_msg void OnDrawEditUI(CCmdUI *pCmdUI);
	afx_msg void OnDrawDelUI(CCmdUI *pCmdUI);
	afx_msg void OnNewPicUI(CCmdUI *pCmdUI);
	afx_msg void OnResetUI(CCmdUI *pCmdUI);
	afx_msg void OnStartUI(CCmdUI *pCmdUI);
	afx_msg void OnStop1UI(CCmdUI *pCmdUI);
	afx_msg void OnStop2UI(CCmdUI *pCmdUI);
	afx_msg void OnStop1Ex(CCmdUI *pCmdUI);
	afx_msg void OnStop2Ex(CCmdUI *pCmdUI);
	afx_msg void OnSelComPort();
	afx_msg void OnColorMode();
	afx_msg void OnUseImageA();
	afx_msg void OnUseImageB();
	afx_msg void OnUseImageC();
	afx_msg void OnUseImageD();
	afx_msg void OnDrawMove();
	afx_msg void OnDrawEdit();
	afx_msg void OnPolyInfo();
	afx_msg void OnNextGame();
	afx_msg void OnStarAdd1();
	afx_msg void OnStarAdd2();
	afx_msg void OnStarSub1();
	afx_msg void OnStarSub2();
	afx_msg void OnDestroy();
	afx_msg void OnPicPath();
	afx_msg void OnPicTime();
	afx_msg void OnDrawDel();
	afx_msg void OnNewPic();
	afx_msg void OnStart();
	afx_msg void OnStop1();
	afx_msg void OnStop2();
	afx_msg void OnReset();
	afx_msg void OnSave();
	//}}AFX_MSG

	virtual void OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint);
	afx_msg void OnDrawMode(UINT uId);

	void		 CheckSave(int iQuery=1);
	void		 SelectStar(int iStar);
	int			 LoadGame(int iIndex);
	void 		 RedrawPoints(int iPolygon);
	void		 StartDraw(int iFixed,CPoint sPoint);
	void		 StartSound(LPCTSTR pSound);
	void		 StartSound(short *pData,unsigned uLen);
	static int   CheckPoint   (int *pCenter,int *pLast,int *pDraw,int *pNext);
	static void  TransPoint   (double *pMatrix,double *pPoint);
	static void  TransPoint   (const double *pMatrix,const double *pPoint,double *pNew);
	static void  TransMultiply(double *pMatrix,double *pOut);
	static void	 TransMultiply(double *pMatrix1,double *pMatrix2,double *pOut);
	static void  DrawMinMaxPoly(int iPoly,int &iMinX,int &iMinY,int &iMaxX,int &iMaxY,int iSet=0);
	static void	 DrawMinMax(int  iUsed,int &iMinX ,int &iMinY,int &iMaxX,int &iMaxY,int iSet=0);
	static void	 PolyToTake(int  iUsed,int &iPolyX,int &iPolyY);
	static void	 TakeToPoly(int  iUsed,int &iPolyX,int &iPolyY);
	static void  PolyToDraw(int &iDrawX,int &iDrawY,int iPolyX,int iPolyY);
	static void  DrawToPoly(int &iPolyX,int &iPolyY,int iDrawX,int iDrawY);
	static void	 DrawToPoly(int  iUsed             ,int iDrawX,int iDrawY);
	static void  PolyToPoly(int  iUsed,int iFrom);
	static int	 PolygonHitTest(int iPosX,int iPosY,int iSize,int *pCoord);
	static int	 DecodePath(const char *pText,double *pItems,int iMax,int iEnd);
	static int   DecodeTransform(const char *pText,double *pTrans);
	static int	 GetArray(const char *pText,double *pArray,int iMax);
	static int 	 PointOnLine(int iPosX,int iPosY,int iUsed1,int iUsed2);
	static int	 PointOnPoly(int iPosX,int iPosY);
	static void  DrawItemsInit();
	
	static	DWORD WINAPI AudioThread(LPVOID pParam);
	static	DWORD WINAPI WaveThread (LPVOID pParam);
	static	DWORD WINAPI ComThread  (LPVOID pParam);
	static	void _cdecl  DrawCallback (void *pParam,CDC *pDc,PAINTSTRUCT *pPaint);
	static	void _cdecl  MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint);
	
	DECLARE_MESSAGE_MAP()


};


//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifndef		_DEBUG	
inline CGameDalliDoc *CGameDalliView::GetDocument()
{

return (CGameDalliDoc*)m_pDocument; 
}
#endif


//*****************************************************************************
//*
//*		PolyToTake
//*
//*****************************************************************************
inline void CGameDalliView::PolyToTake(int iUsed,int &iPolyX,int &iPolyY)
{
	int		iStep;
	int		iPoly;
	
	iPoly	= m_aDrawPoly[iUsed];
	iStep	= m_aDrawStep[iUsed];

	iPolyX  = m_aPolygons[MAX_PT*2*iPoly+iStep*2+0];
	iPolyY  = m_aPolygons[MAX_PT*2*iPoly+iStep*2+1];
}

//*****************************************************************************
//*
//*		TakeToPoly
//*
//*****************************************************************************
inline void CGameDalliView::TakeToPoly(int iUsed,int &iPolyX,int &iPolyY)
{
	int		iStep;
	int		iPoly;
	
	iPoly	= m_aDrawPoly[iUsed];
	iStep	= m_aDrawStep[iUsed];

	m_aPolygons[MAX_PT*2*iPoly+iStep*2+0]	= iPolyX;
	m_aPolygons[MAX_PT*2*iPoly+iStep*2+1]	= iPolyY;
}

//*****************************************************************************
//*
//*		PolyToDraw
//*
//*****************************************************************************
inline void CGameDalliView::PolyToDraw(int &iDrawX,int &iDrawY,int iPolyX,int iPolyY)
{
	iDrawX	= ((iPolyX*m_iDrawMul)/m_iDrawDiv)+m_iDrawAddX;
	iDrawY	= ((iPolyY*m_iDrawMul)/m_iDrawDiv)+m_iDrawAddY;
}

//*****************************************************************************
//*
//*		DrawToPoly
//*
//*****************************************************************************
inline void CGameDalliView::DrawToPoly(int &iPolyX,int &iPolyY,int iDrawX,int iDrawY)
{
	iPolyX	= ((iDrawX-m_iDrawAddX)*m_iDrawDiv)/m_iDrawMul;
	iPolyY	= ((iDrawY-m_iDrawAddY)*m_iDrawDiv)/m_iDrawMul;
}

//*****************************************************************************
//*
//*		DrawToPoly
//*
//*****************************************************************************
inline void CGameDalliView::DrawToPoly(int iUsed,int iDrawX,int iDrawY)
{
	int		iStep;
	int		iPoly;
	
	iPoly	= m_aDrawPoly[iUsed];
	iStep	= m_aDrawStep[iUsed];

	m_aPolygons[MAX_PT*2*iPoly+iStep*2+0] = ((iDrawX-m_iDrawAddX)*m_iDrawDiv)/m_iDrawMul;
	m_aPolygons[MAX_PT*2*iPoly+iStep*2+1] = ((iDrawY-m_iDrawAddY)*m_iDrawDiv)/m_iDrawMul;
}

//*****************************************************************************
//*
//*		PolyToPoly
//*
//*****************************************************************************
inline void CGameDalliView::PolyToPoly(int iUsed,int iFrom)
{
	int		iStep1;
	int		iPoly1;
	int		iStep2;
	int		iPoly2;
	
	iPoly1	= m_aDrawPoly[iUsed];
	iStep1	= m_aDrawStep[iUsed];
	iPoly2	= m_aDrawPoly[iFrom];
	iStep2	= m_aDrawStep[iFrom];

	m_aPolygons[MAX_PT*2*iPoly1+iStep1*2+0] = m_aPolygons[MAX_PT*2*iPoly2+iStep2*2+0];
	m_aPolygons[MAX_PT*2*iPoly1+iStep1*2+1] = m_aPolygons[MAX_PT*2*iPoly2+iStep2*2+1];
}

#endif

