//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameDalli.h"
#include	"GameDalliDoc.h"
#include	"GameDalliView.h"
#include	"MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNCREATE(CMainFrame,CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame,CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_ZOOM							,OnZoom)
	ON_COMMAND(ID_STATUS_BAR_FLAT				,OnFlatBar)
	ON_COMMAND(ID_FIXWINDOW						,OnFixWindow)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT 	,OnFlatBarUI)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW			,OnFixWindowUI)
	//}}AFX_MSG_MAP
	ON_MESSAGE(ID_SETSTATUSBAR					,OnSetStatusbar)
	ON_APP_MESSAGE()
	ON_MENUICON()
	ON_ENUMWND()
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR,												// Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};

MENUICON_PROC(CMainFrame)
ENUMWND_PROC (CMainFrame)
LAST_PLACE   (CMainFrame)
APP_PROC     (CMainFrame)


//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
//  CMainFrame Konstruktion/Zerstrung
CMainFrame::CMainFrame()
{
CRegKeys	sKey;


	m_bFlatMode		= TRUE;
	m_bGamerBarOn	= FALSE;
	m_bWindowFixed	= FALSE;
	m_iZoom			= 0;
	
	MonitorInit();
	
	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bFlatMode  ,"FlatMode");
	sKey.Get(m_bGamerBarOn,"ShowGamerBar");


	ENUMWND_REGISTER("GameDalli");


	
}

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bFlatMode,"FlatMode");
	sKey.Set(m_bGamerBarOn,"ShowGamerBar");


}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD		dwStyle;
CRect		sRect;


	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

			   
	if(!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;
		}

	if(!m_wndToolBar.CreateEx(this,dwStyle,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}
	
	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}

	sRect.left	 = 0;
	sRect.right	 = 85;
	sRect.top	 = 0;
	sRect.bottom = 200;

	m_cDrawBox.Create(WS_VISIBLE|WS_CHILD|WS_TABSTOP|CBS_DROPDOWNLIST,sRect,&m_wndToolBar,ID_DRAWMODE);
	m_cDrawBox.AddString("Spielen"   );
	m_cDrawBox.AddString("Zeichnen"  );
	m_cDrawBox.AddString("Sortieren" );
	m_cDrawBox.AddString("Polygon 1" );
	m_cDrawBox.AddString("Polygon 2" );
	m_cDrawBox.AddString("Polygon 3" );
	m_cDrawBox.AddString("Polygon 4" );
	m_cDrawBox.AddString("Polygon 5" );
	m_cDrawBox.AddString("Polygon 6" );
	m_cDrawBox.AddString("Polygon 7" );
	m_cDrawBox.AddString("Polygon 8" );
	m_cDrawBox.AddString("Polygon 9" );
	m_cDrawBox.AddString("Polygon 10");
	m_cDrawBox.AddString("Polygon 11");
	m_cDrawBox.AddString("Polygon 12");
	m_cDrawBox.AddString("Polygon 13");
	m_cDrawBox.AddString("Polygon 14");
	m_cDrawBox.AddString("Polygon 15");
	m_cDrawBox.AddString("Polygon 16");
	m_cDrawBox.AddString("Polygon 17");
	m_cDrawBox.AddString("Polygon 18");
	m_cDrawBox.AddString("Polygon 19");
	m_cDrawBox.AddString("Polygon 20");
	m_cDrawBox.SetCurSel(0);
	m_cDrawBox.SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));

	m_wndToolBar.AddControl(&m_cDrawBox,ID_DRAWMODE);


	sRect.SetRect(400,1,400,1);
	ClientToScreen(&sRect);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	RecalcLayout();
	MenuIconsInit(IDR_MAINFRAME);
	
	m_bOldStausBar = m_wndStatusBar.IsVisible();	
	m_bOldToolBar  = m_wndToolBar  .IsVisible();	


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CMainFrame::OnDestroy()
{

	
	LAST_PLACE_GET();


	CFrameWnd::OnDestroy();	
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &sCreate)
{
	

	LAST_PLACE_SET(&sCreate);


	if(!CFrameWnd::PreCreateWindow(sCreate))
		{
		return FALSE;
		}


return TRUE;
}


#ifdef		_DEBUG						

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext &dc) const
{
	CFrameWnd::Dump(dc);
}

#endif


//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	uStyle;


	uStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(uStyle,uStyle^TBSTYLE_FLAT);
	m_bFlatMode=(uStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}

}

//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CMainFrame::OnFixWindowUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CMainFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}

//*****************************************************************************
//*
//*		OnSetStatusbar
//*
//*****************************************************************************
LRESULT CMainFrame::OnSetStatusbar(WPARAM wParam,LPARAM lParam)
{
LPCTSTR		pText=(LPCTSTR)lParam;


	m_wndStatusBar.SetPaneText(wParam,pText);


return 0;
}

//*****************************************************************************
//*
//*		OnZoom
//*
//*****************************************************************************
void CMainFrame::OnZoom()
{
CGameDalliView *pView;
UINT			uStyle;



	if(m_iZoom)											// Zoom rckgngig machen
		{
		if(m_bOldStausBar && !m_wndStatusBar.IsVisible())
			{
			ShowControlBar(&m_wndStatusBar,TRUE,FALSE);
			}

		if(m_bOldToolBar && !m_wndToolBar.IsVisible())
			{
			ShowControlBar(&m_wndToolBar,TRUE,FALSE);
			}

		   pView=(CGameDalliView*)GetActiveView();
		if(pView)
			{
			uStyle	= GetWindowLong(pView->m_hWnd,GWL_EXSTYLE);
					  SetWindowLong(pView->m_hWnd,GWL_EXSTYLE,uStyle|WS_EX_CLIENTEDGE);
			}

		uStyle = GetStyle();
		SetStyle(this,uStyle|WS_THICKFRAME|WS_BORDER|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_CAPTION);
		SetMenu(CMenu::FromHandle(m_hMenuDefault));
		if(m_iZoom==2)ShowWindow(SW_SHOWMAXIMIZED);
		else		  ShowWindow(SW_SHOWNORMAL);
		
		m_iZoom = 0;
		pView->SetZoom(0);
		RedrawWindow();
		return;
		}



	if(IsZoomed())
		{
		ShowWindow(SW_SHOWNORMAL);
		m_iZoom = 2;
		}
	else{
		m_iZoom = 1;
		}


	if(m_wndStatusBar.IsVisible())
		{
		ShowControlBar(&m_wndStatusBar,FALSE,FALSE);
		m_bOldStausBar = TRUE;
		}
	else{
		m_bOldStausBar = FALSE;
		}

	if(m_wndToolBar.IsVisible())
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		m_bOldToolBar = TRUE;
		}
	else{
		m_bOldToolBar = FALSE;
		}

	uStyle   = GetStyle();
	SetStyle(this,uStyle&~(WS_THICKFRAME|WS_BORDER|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_CAPTION));
	SetMenu(0);
	
	   pView=(CGameDalliView*)GetActiveView();
	if(pView)
		{
		uStyle	= GetWindowLong(pView->m_hWnd,GWL_EXSTYLE);
				  SetWindowLong(pView->m_hWnd,GWL_EXSTYLE,uStyle&~WS_EX_CLIENTEDGE);
		}


	ShowWindow(SW_SHOWMAXIMIZED);
	if(pView)pView->SetZoom(m_iZoom);

	RedrawWindow();
}
